<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" />
  <title>Game survey</title>
</head>
<body>
  
<?php
  try {
    /**************************************
    * Create databases and                *
    * open connections                    *
    **************************************/
 
    // Create (connect to) SQLite database in file
    $file_db = new PDO('sqlite:surveydb');
    // Set errormode to exceptions
    $file_db->setAttribute(PDO::ATTR_ERRMODE, 
                            PDO::ERRMODE_EXCEPTION);
 
    /**************************************
    * Create table     surveyWP2013                  *
    **************************************/
 
    // Create table messages
    $file_db->exec("CREATE TABLE IF NOT EXISTS surveyWP2013 (
                    id INTEGER PRIMARY KEY, 
                    reviewer TEXT, 
					developer TEXT,
                    place INTEGER, 
                    comments TEXT)");
	
	//read names array to loop through
	$names = file("names.txt", FILE_IGNORE_NEW_LINES); 
	
	// Prepare INSERT statement to SQLite3 file db
    $insert = "INSERT INTO surveyWP2013 (reviewer, developer, place, comments) 
                VALUES (:reviewer, :developer, :place, :comments)";
    $stmt = $file_db->prepare($insert);
	
	
    // Bind parameters to statement variables
    $stmt->bindParam(':reviewer', $reviewer);
	$stmt->bindParam(':developer', $developer);
    $stmt->bindParam(':place', $place);
    $stmt->bindParam(':comments', $comment);
	
	$reviewer = $_POST['reviewer'];
	foreach ($names as $name) 
	{
		$developer = $name;
		$place = $_POST[$name];
		
		if($_POST[$name.'comments'] && $_POST[$name.'comments'] != 'Your comments here')
			$comment = $_POST[$name.'comments'];
		else
			$comment='';
		// Execute statement
		$stmt->execute();
	}

	echo "Thanks for sharing your user experience, dear $reviewer. Have a great day!<br>";
	
	//test insertion by selecting all
	
	$quoted_reviewer = $file_db->quote($reviewer);
	$results = $file_db->query("SELECT * FROM surveyWP2013 WHERE reviewer={$quoted_reviewer}");
	echo 'Reviewed by '.$reviewer.':<br>';
	foreach ($results as $row) {
		
		echo '&nbsp;For: '.$row['developer'].'  place:'.$row['place'].' comment:'.$row['comments'].'<br>';
    }	
	
	$file_db = null;
  }
  catch(PDOException $e) {
    // Print PDOException message
    echo $e->getMessage();
  }
?>


</body>
</html>
