/*************************
    Init (Main) Function
*************************/

function init() {        
    // place game objects on the screen
    var container = document.getElementById("container");
    container.innerHTML = "<h1>Andrew's Checkers Game -- CSCI 311 Assignment #2</h1>"+
        "<hr />"+
        "<br /><div id='left'>"+
            "<div id='turn'>"+
                "<h3>It is Andrew's turn.</h3>"+
            "</div>"+
            "<div id='score'>"+
                "<h3>Score</h3>"+
                "<hr />"+
                "<table id='players'>"+
                "</table></div><br />"+
                "<div id='options'>"+
                "<h3>Options</h3>"+
                "<hr />"+
                "<form><input type='button' id='newGameButton' onClick='startNewGame()' value='Start a New Match' /><br />"+
                "<input type='button' id='rulesButton' onClick='showRules()' value='Game Rules' /></form></div>"+
            "</div>"+
        "</div>"+
        "<div id='board'>"+
            "<canvas id='gameCanvas' width='500' height='500'>"+
            "</canvas>"+
        "</div>"+
        "<br />";
        
    // get the players from local storage
    var playerArray = loadGame();

    // create a game manager, and start the game
    var engine = new GameManager(playerArray[0], playerArray[1]);
    engine.startGame();
}

// Start a new game with the given player names
function login() {
    // get the names of the players
    var player1 = document.getElementById("player1");
    var player2 = document.getElementById("player2");
    var name1 = player1.value;
    var name2 = player2.value;
    
    // set local storage
    saveGame(new Player(name1, "W"), new Player(name2, "B"));
    
    // hide login information
    hideLogin();
    
    // start game
    init();

}

// Hide the login information
function hideLogin() {
    var login = document.getElementById("login");
    login.innerHTML = "";
}

// start a new match with new players
function startNewGame() {
    newGame();
    location.reload();
}

// show the rules page
function showRules() {
    window.open("rules.html",'_blank');
}
