/**************************
     Storage Functions
**************************/

// function to save game (player objects) to local storage
function saveGame(player1, player2) 
{
    // save player info to local storage
    localStorage.setItem("player1", JSON.stringify(player1));
    localStorage.setItem("player2", JSON.stringify(player2));
}

// function to get the books from local storage
function loadGame() 
{
    // get player info
	var player1 = localStorage.getItem("player1");
	var player2 = localStorage.getItem("player2");
	
	if (!player1 && !player2) {
	    // if there are no books in local storage, initialize array
		playerArray = new Array();
	}
	else {
	    // if there are books in local storage, get and parse them
		playerArray = new Array();
		playerArray.push(JSON.parse(player1));
		playerArray.push(JSON.parse(player2));
	}
	
	// return the object array
	return playerArray;
}

// function to clear local storage and start a new game
function newGame()
{
    // Clear the saved players
    localStorage.removeItem("player1");
    localStorage.removeItem("player2");
}

// function that checks if there is a saved game, and then
// starts the game if there is
function checkSave()
{
    // check if there are saved players
    var playerArray = loadGame();
    
    // if there are players, start the game, skip login
    if (playerArray.length == 2) {
        hideLogin();
        init();
    }
}
