/* Board Object */

function Board (boardSize, defaultCellValue)
{

    this.boardSize = boardSize;
    this.defaultCellValue = defaultCellValue;

    this.data = new Array(this.boardSize);
    
    for (var i=0;i<this.boardSize;i++) {
        this.data[i] = new Array (this.boardSize);
    }
    
    for (var i=0;i<this.boardSize;i++) {
        for (var j=0;j<this.boardSize;j++) {
            this.data[i][j] = defaultCellValue;
        }
    }
}

Board.prototype.reset = function ()
{
    for (var i=0;i<this.boardSize;i++) {
        for (var j=0;j<this.boardSize;j++) {
            this.data[i][j] = this.defaultCellValue;
        }
    }
}

Board.prototype.checkWin = function (x,y) {
    /*vertical win*/
    var numInRow = 0; 
  
    for (var i=0;i<this.boardSize;i++) {
        if (this.data[x][i] === this.data[x][y]) {
            numInRow++;
            if (i < this.boardSize-1) {
                if (numInRow === 5 && (this.data[x][i+1] != this.data[x][y])) {
                    return true;
                }
            }
            else {
                if (numInRow === 5) {
                    return true;
                }
            }
        }
        else {
            numInRow = 0;
        }
    }
    /*horizantal win*/
    numInRow = 0;

    for (var i=0;i<this.boardSize;i++) {
        if (this.data[i][y] === this.data[x][y]) {
            numInRow++;
            if (i < this.boardSize-1) {
                if (numInRow === 5 && (this.data[i+1][y] != this.data[x][y])) {
                    return true;
                }
            }
            else {
                if (numInRow === 5) {
                    return true;
                }
            }
        }
        else {
            numInRow = 0;
        }
    }

    /* diagonal win */
    numInRow = 0;

    if (x===y) {
        for (var i=0;i<this.boardSize;i++) {
            if (this.data[i][i] === this.data[x][y]) {
                numInRow++;
                if (i < this.boardSize-1) {
                    if (numInRow === 5 && (this.data[i+1][i+1] != this.data[x][y])) {
                        return true;
                    }
                }
                else {
                    if (numInRow === 5) {
                        return true;
                    }
                }
            }
            else {
                numInRow = 0;
            }
        }
    }

  
    if (x>y) {
        for (var i=0;i<this.boardSize-(x-y);i++) {
            if (this.data[x-y+i][i] === this.data[x][y]) {
                numInRow++;
                if (i < this.boardSize-1) {
                    if (numInRow === 5 && (this.data[x-y+i+1][i+1] != this.data[x][y])) {
                        return true;
                    }
                }
                else {
                    if (numInRow === 5) {
                        return true;
                    }
                }
            }
            else {
                numInRow = 0;
            }
        }
    }


    if (y>x) {
        for (var i=0;i<this.boardSize-(y-x);i++) {
            if (this.data[i][y-x+i] === this.data[x][y]) {
                numInRow++;
                if (i < this.boardSize-1) {
                    if (numInRow === 5 && (this.data[i+1][y-x+i+1] != this.data[x][y])) {
                        return true;
                    }
                }
                else {
                    if (numInRow === 5) {
                        return true;
                    }
                }
            }
            else {
                numInRow = 0;
            }
        }
    }

    return false;   
}
