/* renderer object */

function Renderer(canvasContext, canvasWidth,boardSize) 
{

    this.context = canvasContext;
    this.width = canvasWidth;
    this.padding = Math.floor(this.width/boardSize)-2; //num pixels of padding around grid
    this.cellWidth = (this.width-this.padding)/boardSize;

}

Renderer.prototype.drawOptions = function (game) {
    var options = document.getElementById("options");
    options.innerHTML = ("<h5>Options</h5>"+
        "<input id='switchPlayers' type='button' value='Switch Players!' onclick='game.loginButton()' />"+
        "<input id='switchPlayers' type='button' value='Start Game!' onclick='game.startButton()' />"+
        "<input id='switchPlayers' type='button' value='Resign Game!' onclick='game.resignButton()' />")
}

Renderer.prototype.drawRecordBoard = function (player1,player2) {
    var recordBoard = document.getElementById("recordBoard");
    recordBoard.innerHTML = ("<h5>Record Board</h5>"+
        "<table>"+
            "<tr>"+
                "<td> Player Name </td>"+
                "<td> Color </td>"+
                "<td> Wins </td>"+
                "<td> Losses </td>"+
            "</tr>"+
            "<tr>"+
                "<td>"+player1.playerName+"</td>"+
                "<td> Black </td>"+
                "<td>"+player1.numWins+"</td>"+
                "<td>"+player1.numLosses+"</td>"+
            "</tr>"+
            "<tr>"+
                "<td>"+player2.playerName+"</td>"+
                "<td> White </td>"+
                "<td>"+player2.numWins+"</td>"+
                "<td>"+player2.numLosses+"</td>"+
            "</tr>"+
        "</table>")
}


Renderer.prototype.drawBoard = function (boardSize) {

    this.context.fillStyle = "rgba(244,160,75,1)";
    this.context.fillRect(0,0,this.width,this.width);

    for (var i=0;i<boardSize;i++) {
	    this.context.beginPath();
	    this.context.moveTo((this.padding),(this.padding)+i*this.cellWidth);
	    this.context.lineTo(this.width-(this.padding),(this.padding)+i*this.cellWidth);
	    this.context.stroke();

	    this.context.beginPath();
	    this.context.moveTo((this.padding)+i*this.cellWidth,(this.padding));
	    this.context.lineTo((this.padding)+i*this.cellWidth,this.width-(this.padding));
	    this.context.stroke();
    }

}

Renderer.prototype.drawTurn = function (currentPlayer) {
    var turn = document.getElementById("turn");
    turn.innerHTML = ("<h5>It's <img src='./img/"+currentPlayer+".png' /> 's turn!</h5>");
}

Renderer.prototype.drawStone = function (x,y,currentPlayer) {

        if (currentPlayer == "black") {
            this.context.fillStyle = "rgba(0,0,0,1)";
        }
        else {
	        this.context.fillStyle = "rgba(255,255,255,1)";
        }

    	var xcell = x*this.cellWidth;
	    var ycell = y*this.cellWidth;

        this.context.beginPath();
        this.context.arc(xcell,ycell,15,0, Math.PI*2, true);
        this.context.closePath();
        this.context.fill();

}
