var game;

function Game(p1name, p2name)
{
	this.KEY_CODES = { 'p1left':37, 'p1right':39, 'p2left':65, 'p2right':68, 'enter':13, 'escape':27 };
	
	this.p1 = new Player(p1name);
	this.p2 = new Player(p2name);
	this.server = 0;
	
	this.canvas = document.getElementById('pong_canvas');
	this.paddles = null
	this.ball = null;
	
	this.winScore = 5;
	
	this.uInterval = null;
	
	this.infoDivs = null;
	
	this.isScore = false;
	this.isStart = true;
	
	this.setup = function()
	{
		this.isStart = true;
		
		this.canvas.width = 400;
		this.canvas.height = 500;
		
		this.paddles = new Array();
		this.ball = new Ball();
		
		document.getElementById("menu").style.display = 'none';
		document.getElementById("end_game").style.display ='none';
		
		this.infoDivs = document.getElementsByClassName("info");
		this.infoDivs[0].childNodes[1].innerHTML = this.p1.name;
		this.infoDivs[0].childNodes[3].innerHTML = '0';
		this.infoDivs[1].childNodes[1].innerHTML = this.p2.name;
		this.infoDivs[1].childNodes[3].innerHTML = '0';
		
		instructions = document.getElementById('instructions');
		names = instructions.getElementsByTagName('span');
		names[1].innerHTML = this.p1.name;
		names[0].innerHTML = this.p2.name;
		
		
		this.p1.score = 0;
		this.p2.score = 0;
		
		var paddle = new Paddle();
		paddle.setY(.02, this.canvas);
		paddle.setX(.5, this.canvas);
		paddle.setC(this.canvas);
	
		this.paddles.push(paddle);
		
		paddle = new Paddle();
		paddle.setY(.98, this.canvas);
		paddle.setX(.5, this.canvas);
		paddle.setC(this.canvas);
		
		this.paddles.push(paddle);
		
		this.server = Math.floor(Math.random()*2);
		
		this.ball.r = 9;
		this.ball.x = 0.5;
		this.ball.y = 0.5;
		if (this.server == 0)
		{
			this.ball.d = (3*Math.PI/2) + .5;
		}
		else
		{
			this.ball.d = (Math.PI/2) + .5;
		}
		this.server = (this.server - 1) * -1;
		this.ball.s = 0.2;
		this.ball.setC(this.canvas);
		
		document.getElementById("start").style.display = 'block';
		document.getElementById("scored").style.display = 'none';
		
		window.addEventListener("keydown", keyDownHandler);
		window.addEventListener("keyup", keyUpHandler);
		window.addEventListener("keyup", menuKeyListener);
		window.addEventListener("keyup", startKeyListener);
	};
	
	this.start = function()
	{
		this.isStart = false;
		this.isScored = false;
		game.uInterval = self.setInterval(function(){game.loop();},8.33);
	};
	this.stop = function()
	{
		game.uInterval = window.clearInterval(game.uInterval);
	};
	
	this.loop = function()
	{
		var context = this.canvas.getContext("2d");
		context.clearRect(0, 0, this.canvas.width, this.canvas.height);
		
		this.ball.update(this.canvas);
		for (var i = 0; i < this.paddles.length; i++)
		{
			this.paddles[i].update(this.canvas);
		}
		
		this.ball.collisions(this.canvas);
		
		this.ball.draw(this.canvas);
		for (var i = 0; i < this.paddles.length; i++)
		{
			this.paddles[i].draw(this.canvas);
		}
	};
	
	this.score = function(player)
	{
		this.stop();
		this.isScored = true; //stop the toggeling of the menu from starting the game
		
		if (player == 0)
		{
			this.p1.score++;
			this.infoDivs[0].childNodes[3].innerHTML = this.p1.score;
			document.getElementById('user_scored').innerHTML = this.p1.name;
			if (this.p1.score >= this.winScore)
			{
				this.endGame(this.p1.name, this.p2.name);
				return;
			}
		}
		else
		{
			this.p2.score++;
			this.infoDivs[1].childNodes[3].innerHTML = this.p2.score;
			document.getElementById('user_scored').innerHTML = this.p2.name;
			if (this.p2.score >= this.winScore)
			{
				this.endGame(this.p2.name, this.p1.name);
				return;
			}
		}
		
		this.ball.x = 0.5;
		this.ball.y = 0.5;
		if (this.server == 0)
		{
			this.ball.d = (3*Math.PI/2) + .5;
		}
		else
		{
			this.ball.d = (Math.PI/2) + .5;
		}
		this.server = (this.server - 1) * -1;
		this.ball.s = 0.2;
		this.ball.setC(this.canvas);
		
		var scored = document.getElementById("scored");
		scored.style.display = 'block';
		window.addEventListener("keyup", startKeyListener);
	};
	
	this.endGame = function(winner, loser)
	{
		var leaderboard = JSON.parse(window.localStorage.getItem("leaderboard"));
		if (leaderboard)
		{
			for (var i = 0; i < leaderboard.length; i++)
			{
				if (leaderboard[i].name.toLowerCase().localeCompare(winner.toLowerCase()) == 0)
				{
					leaderboard[i].played++;
					leaderboard[i].wins++;
					leaderboard[i].rank = ((leaderboard[i]['wins']/leaderboard[i]['played'])*10).toFixed(2);
					break;
				}
				else if (i+1 == leaderboard.length)
				{
					leaderboard.push({'name':winner, 'played':1, 'wins':1, 'losses':0, 'rank':10});
					break;
				}
			}
			for (var i = 0; i < leaderboard.length; i++)
			{	
				if (leaderboard[i].name.toLowerCase().localeCompare(loser.toLowerCase()) == 0)
				{
					leaderboard[i].played++;
					leaderboard[i].losses++;
					leaderboard[i].rank = ((leaderboard[i]['wins']/leaderboard[i]['played'])*10).toFixed(2);
					break;
				}
				else if (i+1 == leaderboard.length)
				{
					leaderboard.push({'name':loser, 'played':1, 'wins':0, 'losses':1, 'rank':0});
					break;
				}
			}
		}
		else
		{	
			leaderboard = new Array();
			
			leaderboard.push({'name':winner, 'played':1, 'wins':1, 'losses':0, 'rank':10});
			leaderboard.push({'name':loser, 'played':1, 'wins':0, 'losses':1, 'rank':0});
		}
		
		saveLeaderboard(leaderboard);
		displayLeaderboard(leaderboard);
		
		window.removeEventListener("keyup", menuKeyListener);
		
		document.getElementById("winner").innerHTML = winner;
		div = document.getElementById("end_game");
		div.style.display = 'block';
	};
	
	this.clean = function()
	{
		window.removeEventListener("keydown", keyDownHandler);
		window.removeEventListener("keyup", keyUpHandler);
		window.removeEventListener("keyup", menuKeyListener);
		window.removeEventListener("keyup", startKeyListener);
	};
}


function Player(name)
{
	this.name = name;
	this.score = 0;
}