function Board(size,defaultValue)
{
    //generate board variables
    this.size = size
    this.horMoves = size * size + size;
    this.verMoves = size * size + size;
    this.defaultValue = defaultValue;

    //define 2d array for horizontal moves
    this.horMoves = new Array(this.size);

    for(var i=0; i<this.size; i++) {
        this.horMoves[i] = new Array(this.size + 1);
    }

    //set all values empty
    for(var i=0; i<this.size; i++) {
        for(var j=0; j<(this.size+1); j++) {
            this.horMoves[i][j] = this.defaultValue;
        }
    }
    //define 2d array for vertical moves
    this.verMoves = new Array(this.size+1);

    for(var i=0; i<this.size+1; i++) {
        this.verMoves[i] = new Array(this.size);
    }

    //set all values empty
    for(var i=0; i<this.size+1; i++) {
        for(var j=0; j<(this.size); j++) {
            this.verMoves[i][j] = this.defaultValue;
        }
    }    
}

Board.prototype.checkMove = function (X,Y,game)
{

    //finds the location of the move and places it, then checks if it creates a box
    for(var i=0; i<=5; i++) {
        for(var j=0; j<=5; j++) {
            if(X > ((i*80)-20) && X < ((i*80)+20) && Y < ((j*80) + 71) && Y > ((j*80) + 11) && this.verMoves[i][j] === 0) {
                game.totalMoves++;
                var scoreCheck = game.currPlayer.score;
                this.verMoves[i][j] = 1;
                game.renderer.renderMoveVer(i,j);
                this.checkPointVer(i,j,game);

                if(game.currPlayer.score === scoreCheck) {
                    game.nextPlayer();
                }

                return;
            }
            if(Y > ((j*80)-20) && Y < ((j*80)+20) && X < ((i*80) + 71) && X > ((i*80) + 11) && this.horMoves[i][j] === 0) {
                game.totalMoves++;
                var scoreCheck = game.currPlayer.score;
                this.horMoves[i][j] = 1;
                game.renderer.renderMoveHor(i,j);
                this.checkPointHor(i,j,game);
                
                if(game.currPlayer.score === scoreCheck) {
                    game.nextPlayer();
                }
                return;
            }
        }    
    }
    return;
}   

Board.prototype.checkPointVer = function (X,Y,game)
{   
    //check the inner boxes
    if(X > 0 && X < 5) {
        if(this.verMoves[X+1][Y] === 1 && this.horMoves[X][Y] === 1 && this.horMoves[X][Y+1] === 1) {
            game.currPlayer.score += 1;
            game.renderer.renderScore(game);
        }
        if(this.verMoves[X-1][Y] === 1 && this.horMoves[X-1][Y] === 1 && this.horMoves[X-1][Y+1] === 1) {
            game.currPlayer.score += 1;
            game.renderer.renderScore(game);
        }
    //check the edges of the board
    } else {
        if(X === 0 && this.verMoves[X+1][Y] === 1 && this.horMoves[X][Y] === 1 && this.horMoves[X][Y+1] === 1) {
            game.currPlayer.score += 1;
            game.renderer.renderScore(game);
        }
        if(X === 5 && this.verMoves[X-1][Y] === 1 && this.horMoves[X-1][Y] && this.horMoves[X-1][Y+1] === 1) {
            game.currPlayer.score += 1;
            game.renderer.renderScore(game);
        }
    }
}

Board.prototype.checkPointHor = function (X,Y,game)
{   
    //check the inner boxes
    if(Y > 0 && Y < 5) {
        if(this.horMoves[X][Y+1] === 1 && this.verMoves[X][Y] === 1 && this.verMoves[X+1][Y]) {
            game.currPlayer.score += 1;
            game.renderer.renderScore(game);
        }
        if(this.horMoves[X][Y-1] === 1 && this.verMoves[X][Y-1] === 1 && this.verMoves[X+1][Y-1] === 1) {
            game.currPlayer.score += 1;
            game.renderer.renderScore(game);
        }
    //check the edges of the board
    } else {
        if(Y === 0 && this.horMoves[X][Y+1] === 1 && this.verMoves[X][Y] && this.verMoves[X+1][Y] === 1) {
            game.currPlayer.score += 1;
            game.renderer.renderScore(game);
        }
        if(Y === 5 && this.horMoves[X][Y-1] === 1 && this.verMoves[X][Y-1] && this.verMoves[X+1][Y-1] === 1) {
            game.currPlayer.score += 1;
            game.renderer.renderScore(game);
        }
    }
}
