var game = {
    dim: {X:5, Y:5},
    playerOne: null,
    playerTwo: null,
    board: null,
    score: null,
    canvas: null,
    renderer: null,
    currPlayer: null,
    totalMoves: 60,
    gameInfo: null,

    nextPlayer: function() {
        if (this.currPlayer === this.playerOne) {
            this.currPlayer = this.playerTwo;
        } else {
            this.currPlayer = this.playerOne;
        }
    },
    
    init: function ()
    {
        var one = prompt("Please enter player one's name");
        var two = prompt("Please enter player two's name");
        this.playerOne = new Player(one,0,0,0);
        this.playerTwo = new Player(two,0,0,0); 
        this.gameInfo = new gameInfo();
        this.playerOne = this.gameInfo.getGameStats(this.playerOne);
        this.playerTwo = this.gameInfo.getGameStats(this.playerTwo);
        this.playerOne.colour = "E81C0C";
        this.playerTwo.colour = "166870";
        this.currPlayer = this.playerOne;
        this.login();
        this.board = new Board(5,0);
        this.renderer = new render(this);
        this.startGame();
    },

    login: function ()
    {
        var submit = document.getElementById("submit");   
        submit.addEventListener("click",this.submitForm,false);
    },

    startGame: function()
    {
        this.totalMoves = 0;
        this.canvas = this.renderer.initCanvas(this);
        this.renderer.renderBoard();
        this.renderer.renderScore(this);
        this.renderer.renderPlayers(this);
    },
    
    submitForm: function(event) 
    {
        window.alert(game.currPlayer.playerName + " has lost by concession.");
        game.currPlayer.losses += 1;
        game.currPlayer.score = 0;
        if (this.currPlayer === this.playerOne) {
            this.playerOne = this.currPlayer;
        } else {
            this.playerTwo = this.currPlayer;
        }
        game.nextPlayer();
        game.currPlayer.wins += 1;
        game.currPlayer.score = 0;
        if (this.currPlayer === this.playerOne) {
            this.playerOne = this.currPlayer;
        } else {
            this.playerTwo = this.currPlayer;
        }
        game.gameInfo.saveGameStats(game.playerOne,game.playerTwo);
        
    },
                          
    coordinates: function(event)
    {
        var totalOffsetX = 0;
        var totalOffsetY = 0;
        var canvasX = 0;
        var canvasY = 0;
        var currentElement = this;

        do{
            totalOffsetX += currentElement.offsetLeft - currentElement.scrollLeft;
            totalOffsetY += currentElement.offsetTop - currentElement.scrollTop;
        }
        while(currentElement = currentElement.offsetParent)

        canvasX = event.pageX - totalOffsetX;
        canvasY = event.pageY - totalOffsetY;


        game.playerMove(canvasX,canvasY);
    },

    playerMove: function(X,Y)
    {
        //length of a single line in pixels
        this.board.checkMove(X,Y,this);
        this.renderer.renderScore(this);
        if(this.totalMoves === 60) {
            if(this.playerOne.score>this.playerTwo.score) {
                this.playerOne.wins += 1;
                this.playerTwo.losses += 1;
                window.alert(this.playerOne.playerName + " has won!")
            }
            else if(this.playerOne.score<this.playerTwo.score) {
                this.playerOne.losses +=1;
                this.playerTwo.wins +=1;
                window.alert(this.playerTwo.playerName + " has won!")
            }
            else if(this.playerONe.score === this.playerTwo.score) {
                window.alert("It's a draw, nobody wins!")
            }
            this.playerOne.score = 0;
            this.playerTwo.score = 0;
            this.gameInfo.saveGameStats(this.playerOne,this.playerTwo);
            location.reload();
        }       
    },    
};


