function render ()
{
    render.prototype.initCanvas = function(game)
    {
        var boardElem = document.getElementById("board");
        boardElem.width = game.dim.X * 80 + 20;
        boardElem.height = game.dim.Y * 80 + 20;
        boardElem.addEventListener('click',game.coordinates,false); 
        this.boardContext = boardElem.getContext("2d");
        var scoreElem = document.getElementById("score");
        scoreElem.width = 400;
        scoreElem.height = 200;
        this.scoreContext = scoreElem.getContext("2d");
        return this;
    }

	render.prototype.renderBoard = function ()
	{
        //pixel padding on the edge
        var p = 10;
        //Loops set lines every 80 pixels
        for (var x = 0; x <= game.dim.X * 80; x += 80) {
            this.boardContext.moveTo(0.5 + x + p, p);
            this.boardContext.lineTo(0.5 + x + p, 400 + p);
        }

        
        for (var x = 0; x <= game.dim.Y * 80; x += 80) {
            this.boardContext.moveTo(p, 0.5 + x + p);
            this.boardContext.lineTo(400 + p, 0.5 + x + p);
        }

        this.boardContext.strokeStyle = "black";
        this.boardContext.stroke();
	};

    render.prototype.renderMoveHor = function(X,Y)
    {
        var CX = X * 80 + 10;
        var CY = Y * 80 + 10;
        this.boardContext.beginPath()
        this.boardContext.moveTo(CX,CY);
        this.boardContext.lineWidth = 6;
        this.boardContext.lineTo(CX+80,CY);
        this.boardContext.strokeStyle = game.currPlayer.colour;
        this.boardContext.stroke();
    };

    render.prototype.renderMoveVer = function(X,Y)
    {
        var CX = X * 80 + 10;
        var CY = Y * 80 + 10;
        this.boardContext.beginPath()
        this.boardContext.moveTo(CX,CY);
        this.boardContext.lineWidth = 6;
        this.boardContext.lineTo(CX,CY+80);
        this.boardContext.strokeStyle = game.currPlayer.colour;
        this.boardContext.stroke();
    };

    render.prototype.renderScore = function(game)
    {
        var scoreElem = document.getElementById("score");
        var x = scoreElem.width / 2;
        var y = scoreElem.height / 2;
        
        this.scoreContext.clearRect(0,0,400,200);
        
        this.scoreContext.fillStyle = "black";
        this.scoreContext.font = "bold 24px Arial";
        this.scoreContext.fillText("SCOREBOARD",0,y);
        
        this.scoreContext.fillStyle = "E81C0C";
        this.scoreContext.font = "bold 24px Arial";
        this.scoreContext.fillText(game.playerOne.playerName + ": " + game.playerOne.score, 0,y+30);

        this.scoreContext.fillStyle = "166870";
        this.scoreContext.font = "bold 24 px Arial";
        this.scoreContext.fillText(game.playerTwo.playerName + ": " + game.playerTwo.score, 0, y+60);

        this.scoreContext.fillstyle = "1BAA8F";
        this.scoreContext.font = "bold 24 px Arial";
        this.scoreContext.fillText("It is " + game.currPlayer.playerName + "'s turn", 0, y+90);
    };

    render.prototype.renderPlayers = function(game)
    {
        var playerBoard = document.getElementById("playerBoard");
        playerBoard.innerHTML = ("<tr>" +
                                    "<td> Name </td>" +
                                    "<td> Wins </td>" +
                                    "<td> Losses </td>" +
                                 "</tr>" +
                                 "<tr>" +
                                    "<td>" + game.playerOne.playerName + "</td>" +
                                    "<td>" + game.playerOne.wins + "</td>" +
                                    "<td>" + game.playerOne.losses + "</td>" +
                                 "<tr>" +
                                    "<td>" + game.playerTwo.playerName + "</td>" +
                                    "<td>" + game.playerTwo.wins + "</td>" +
                                    "<td>" + game.playerTwo.losses + "</td>" +
                                "</tr>")
    }
}

