function init(){
	var s = new gameState();
	var b = new gameBoard();

	var newGameButton = document.getElementById("newGameButton");
	newGameButton.addEventListener('click', function(){ newGame(s, b); }, false);

	var rulesButton = document.getElementById("rulesButton");
	rulesButton.addEventListener('click', showRules, false);

	var statsButton = document.getElementById("statsButton");
	statsButton.addEventListener('click', showStats, false);

	var login1Button = document.getElementById("login1Button");
	login1Button.addEventListener('click', function(){ login1(s);}, false);

	var login2Button = document.getElementById("login2Button");
	login2Button.addEventListener('click', function(){ login2(s);}, false);

	drawStart();
}


function newGame(gameState, board){
	//new game button function
	if (gameState.getState() !== "off"){ //game is running
		alert("Please finish or quit the current game");
		return;
	}	
	if (gameState.startGame() === 0){ //need more players
		alert("Please login two players.");
		return;
	}
	board.newGame();
	drawBoard(board);
	updateBottomPanel(gameState);
	canvasElem = document.getElementById("boardCanvas");
	//set up game's box click event listener
	canvasElem.addEventListener("click",function(e){boardClickHandler(e, board, gameState);}, false);
}

function showRules(){
	//rules button function
	window.open('./rules.html',"_blank","width=1000,menubar=0,status=0,scrollbars=1",false);
}

function showStats(){
	//stats button function
	window.open('./stats.html',"_blank","width=1000,menubar=0,status=0,scrollbars=1",false);
}

function login1(gameState){
	//login player1 button function
	var login1TextInput = document.getElementById("login1Text");
	var login1Text = login1TextInput.value;

	if (login1Text === ""){
		alert("Please enter a valid name");
		return;
	}
	gameState.addPlayer(login1Text, 1);

	var player1NameDiv = document.getElementById("login1");
	player1NameDiv.innerHTML = login1Text + "<input id=\"logout1Button\" type=\"button\" value=\"Logout\"/>";

	var logout1Button = document.getElementById("logout1Button");
	logout1Button.addEventListener('click', function(){ logout1(gameState);}, false);

	var p1m = document.getElementById('player1Mines');
	p1m.innerHTML = "0"
}

function login2(gameState){
	//login player2 button function
	var login2TextInput = document.getElementById("login2Text");
	var login2Text = login2TextInput.value;

	if (login2Text === ""){
		alert("Please enter a valid name");
		return;
	}
	gameState.addPlayer(login2Text, 2);
	
	var player2NameDiv = document.getElementById("login2");
	player2NameDiv.innerHTML = login2Text + "<input id=\"logout2Button\" type=\"button\" value=\"Logout\"/>";

	var logout2Button = document.getElementById("logout2Button");
	logout2Button.addEventListener('click', function(){ logout2(gameState);}, false);

	var p2m = document.getElementById('player2Mines');
	p2m.innerHTML = "0"
}

function logout2(gameState){
	//logout player2 button function
	if (gameState.getState() !== "off"){
		gameState.playerLeftGame(2);
	} else {
		drawStart();
	}
	gameState.deletePlayer(2);
	var player2NameDiv = document.getElementById("login2");
	player2NameDiv.innerHTML = "<input id=\"login2Text\" type=\"text\" name=\"Username 2\"/><input id=\"login2Button\" type=\"button\" value=\"Login\"/>"
	var login2Button = document.getElementById("login2Button");
	login2Button.addEventListener('click', function(){ login2(gameState);}, false);
}

function logout1(gameState){
	//logout player1 button function
	if (gameState.getState() !== "off"){
		gameState.playerLeftGame(1);
	} else {
		drawStart();
	}
	gameState.deletePlayer(1);
	var player1NameDiv = document.getElementById("login1");
	player1NameDiv.innerHTML = "<input id=\"login1Text\" type=\"text\" name=\"Username 1\"/><input id=\"login1Button\" type=\"button\" value=\"Login\"/>"
	var login1Button = document.getElementById("login1Button");
	login1Button.addEventListener('click', function(){ login1(gameState);}, false);
}

function play(board,i,j){
//plays a square on the board and then 
//renders the board.
//returns 2 if a invalid turn was played
//returns 1 if the player finds a mine
//returns 0 if the player does not
//throws a not a valid move exception if the move is invalid
	if (board.checkValidMove(i,j)){
		board.flip(i,j);
		drawBoard(board);
	} else {
		return 2;
	}
	if (board.getSquare(i,j) === "M"){
		return 1;
	}
	return 0;
}


function boardClickHandler (e, board, gameState) {
//A large portion of this code was written by Dr. Marina Barsky
//function figures out the cell x and y coordinates of a click on
//the canvas and then attempts to play that square.
//The bottom panel is then re-rendered.
	if (gameState.getState() === "off")
		return;
	var x;
	var y;
	if (e.pageX || e.pageY) {
		x = e.pageX;
		y = e.pageY;
	} else {
		x = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
		y = e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
	}

	var clickedCellX = Math.floor((x - canvasElem.offsetLeft)/30);
	var clickedCellY = Math.floor((y - canvasElem.offsetTop)/30);
	var result = play(board,clickedCellX,clickedCellY);
	gameState.countTurn(result); //immediately returns if (result === 2) aka invalid move
	updateBottomPanel(gameState);
}
