function drawBoard(board){
//draws the entire boar
	for (var i=0; i < 10 ; i++){
		for ( var j=0; j < 10 ; j++){				
			drawSquare(board,i,j);
		}
	}

}

function drawSquare(board, i,j){
//draws a single square on the board
	canvasElem = document.getElementById("boardCanvas");
	context = canvasElem.getContext("2d");

	if (board.getState(i,j) === "P"){
		if (board.board[i][j] !== "M"){
			var baseIMG = new Image();
			baseIMG.onload = function() { 
				context.drawImage(baseIMG, (i*30), (j*30));
				context.font = "1.5em cambria arial";
				context.textBaseline = "middle";
				context.textAlign = "center";	
				context.fillStyle = getColor(board.board[i][j]);
				context.fillText(board.board[i][j], ((i*30)+15), ((j*30)+15));
			};
			baseIMG.src = 'img/BASE.jpg';
		} else {
			var mineIMG = new Image();
			mineIMG.onload = function() { 
				context.drawImage(mineIMG, (i*30), (j*30));
			};
			mineIMG.src = 'img/MINE.jpg';
		}
	} else {
		var flippedIMG = new Image();

		flippedIMG.onload = function(){
			context.drawImage(flippedIMG, (i*30), (j*30));
		}
		flippedIMG.src = 'img/FLIPPED.jpg';		
	}
}

function getColor(str){
//returns the font color corresponding with the number of adjacent mines
	if (str === "1")
		return "rgb(0,0,255)";
	if (str === "2")
		return "rgb(0,130,0)";
	if (str === "3")
		return "rgb(255,0,0)";
	if (str === "4")
		return "rgb(0,132,0)";
	if (str === "5")
		return "rgb(132,0,0)";
	if (str === "6")
		return "rgb(0,130,132)";
	if (str === "7")
		return "rgb(132,0,132)";
	if (str === "8")
		return "rgb(0,0,0)";
	if (str === "M")
		return "rgba(0,0,0,1)";
	return "rgba(255,255,255,0)";
}

function drawStart(){
//draws the start splash screen
	var p1m = document.getElementById('player1Mines');
	p1m.innerHTML = "0"
	var p2m = document.getElementById('player2Mines');
	p2m.innerHTML = "0"


	canvasElem = document.getElementById("boardCanvas");
	context = canvasElem.getContext("2d");

	var startIMG = new Image();
	startIMG.onload = function(){
		context.drawImage(startIMG, 0, 0);
	}
	startIMG.src = 'img/start.jpg';
}

function drawWinner(num){
//draws the winning splash screen with the winner shown as player "num"
	canvasElem = document.getElementById("boardCanvas");
	context = canvasElem.getContext("2d");

	var winIMG = new Image();
	winIMG.onload = function(){
		context.drawImage(winIMG, 0, 0);
		context.font = "1.5em cambria arial";
		context.textBaseline = "middle";
		context.textAlign = "center";	
		context.fillStyle = "black";
		context.fillText("Player " + num, 150, 200);
	}
	winIMG.src = 'img/winner.jpg';
}

function updateBottomPanel(gameState){
//updates the bottom panel between turns
	var playerTurn = gameState.getTurn();
	//show turn player number turn at top
	var tm = document.getElementById('turnmanager');
	tm.innerHTML = "Turn: Player " + playerTurn;

	//make current player's box tinged green
	if (playerTurn === 1) {
		document.getElementById('player1').style.background = 'rgba(210,250,210,.8)';
		document.getElementById('player2').style.background = 'rgba(210,210,210,.8)';
	} else if (playerTurn === 2) {
		document.getElementById('player2').style.background = 'rgba(210,250,210,.8)';
		document.getElementById('player1').style.background = 'rgba(210,210,210,.8)';		
 	}
	//update mines found
	var p1m = document.getElementById('player1Mines');
	p1m.innerHTML = gameState.getMinesFound(1);
	var p2m = document.getElementById('player2Mines');
	p2m.innerHTML = gameState.getMinesFound(2);
	
};





