function gameState (){
	this.state = "off";
	this.player1 = null;
	this.player2 = null;
	this.player1Name = null;
	this.player2Name = null;
	this.playerTurn = 0;

	this.checkWin = function(){
	//checks if a player has won, if so adds stats, ends the game, then renders the win screen
	//num corresponds to player number
		if (this.player1.getMinesFound() === 11){
			this.player1.gameWon();
			this.player2.gameLost();
			this.endGame();
			drawWinner(1);
		}
		if (this.player2.getMinesFound() === 11){
			this.player2.gameWon();
			this.player1.gameLost();
			this.endGame();
			drawWinner(2);
		}
	};

	this.playerLeftGame = function(num){
	//records a player leaving the game, if so adds stats, ends the game, then renders the win screen
	//num corresponds to player number
		if (num === 1) {
			this.player2.gameWon();
			this.player1.gameLeft();
			this.endGame();
			drawWinner(2);
		} else if (num === 2){
			this.player1.gameWon();
			this.player2.gameLeft();		
			this.endGame();
			drawWinner(1);			
		}
	}

	this.checkForTwoPlayers = function(){
	//returns 1 if twoplayers exist, returns 0 otherwise
		if (this.player1Name === null || this.player2Name === null)
			return 0;
		return 1;
	};
	
	this.addPlayer = function (name, num){
	//adds a player, num corresponds to player number
		if (num === 1)
			this.player1Name = name;
		if (num === 2)
			this.player2Name = name;
	};
	
	this.startGame = function(){
	//returns 0 if the game is already running ot two players do not exist
	//returns 1 if a new game is successfully started
		if (this.checkForTwoPlayers() === 1 && this.state === "off"){
			if (this.player1 === null)
				this.player1 = new Player(this.player1Name);
			if (this.player2 === null)
				this.player2 = new Player(this.player2Name);
			this.player1.newGame();
			this.player2.newGame();
			//calculate randomly which player goes first
			this.playerTurn = 1 + Math.floor(Math.random()*2);
			this.state = "on";
			return 1;
		}
		return 0;
	};

	this.endGame = function(){
	//ends the current game and updates each player's stats
		this.state = "off";
		this.playerTurn = "0";
		savePlayer(this.player1);
		savePlayer(this.player2);
	};
	
	this.countTurn = function(result){
	//counts a turn based on the parameter result
	//result === 2 corresponds to an invalid turn
	//result === 1 corresponds to a mine found, 
	//    adds a mine to current turn's player and checks for win
	//result as anyting else corresponds to changing player turn
	//    changes which player's turn it is to the other player
		if (result === 2){
			return;
		} else if (result === 1){
			if (this.playerTurn === 1){
				this.player1.addMine();
			} else {
				this.player2.addMine();
			}
			this.checkWin();
		} else {
			if (this.playerTurn === 1){
				this.playerTurn = 2;
			} else {
				this.playerTurn = 1;
			}
		}
	};
	
	this.getState = function(){
		return this.state
	};

	this.getTurn = function(){
		return this.playerTurn;
	};

	this.getMinesFound = function(playerNum){
	//returns the numer of mines found by the player number corresponding 
	//with the passed parameter
		if (playerNum === 1) {
			return this.player1.getMinesFound();
		} else if (playerNum === 2) {
			return this.player2.getMinesFound();
		}
	};

	this.deletePlayer = function(num){
	//deletes player corresponding with passed parameter num from the game state
		if (num === 1){
			this.player1Name = null;
			this.player1 = null;
		} else if (num === 2) {
			this.player2Name = null;
			this.player2 = null;
		}
	};
}
