var game = {
   dim: {nX:10, nY:10},
   player1: null,
   player2: null,
   board: null,
   stats: null,
   storage: null,
   gameName: "DotsGame",

   initBoard: function() {

      var canvasElem = document.getElementById('boardCanvas');
      context = canvasElem.getContext("2d");    

      var h = canvasElem.height;
      var w = canvasElem.width;    

      this.board = new Board(h, w, [], [], 10, []);
      var p1name = prompt("Enter Player 1's name:", "name here");
      var p2name = prompt("Enter Player 2's name:", "name here");

      this.storage = new Storage(this.gameName);
      this.stats = this.storage.getGameStats();
      var str = JSON.stringify(this.stats);
      var array = separateString(str);

      if(str != "{}") 
         loadscoreTable(array);

      this.player1 = new player(p1name, 0, 'blue', 1, 0, 0, 0);
      this.player2 = new player(p2name, 0, 'red', 0, 0, 0, 0);

      drawBoard(this.player1, this.player2, context);

      canvasElem.addEventListener("click",this.playerMove, false);

   },


   turnManager: function () {
  
      if(this.player1.turn === 0) {
         this.player1.turn = 1;
         this.player2.turn = 0;
      
         context.fillStyle = "rgb(204,206,255)"; 
         context.fillRect(200, 570, 150, 40);

         context.fillStyle ='black';
         context.textAlign = 'center';
         context.font = '20px Calibri'; 
         context.fillText(this.player2.name+"'s turn", 275, 600);

      } else {
         this.player1.turn = 0;
         this.player2.turn = 1;
  
         context.fillStyle = "rgb(204,206,255)";
         context.fillRect(200, 570, 150, 40);

         context.fillStyle ='black';
         context.font = '20px Calibri'; 
         context.textAlign = 'center';
         context.fillText(this.player1.name+"'s turn", 275, 600);
      }

   },

   playerMove: function (event) {
      var x = event.x;
      var y = event.y;

      var canvas = document.getElementById("boardCanvas")

      x -= canvas.offsetLeft;
      y -= canvas.offsetTop;

      if(x >= 10 && x <= 60 && y >= 580 && y <= 600) {    // fixed positions on the screen
          window.location.href = 'dotsrules.html';
      }

      if(x >= 85 && x <= 125 && y >= 580 && y <= 600) {   // fixed positions on the screen
         game.Reset();
      }

      if(x >= 430 && x <= 530 && y >= 580 && y <= 600) {  // fixed positions on the screen
         showScores();
      }

      for(var i = 0;i < 10; i++) {
         for(var j = 0; j < 10; j++) {
            if(x >= (game.board.k[i]-8) && x <= (game.board.k[i]+8) && y >= (game.board.k[j]-8) && y <= (game.board.k[j]+8)){
               game.drawLines(x,y,i,j); 
               game.turnManager();
            }
         }
      }
   },

   Reset: function() {
      var currPlayer;
      if(this.player1.turn === 0) {
         currPlayer = this.player1;
      } else {
         currPlayer = this.player2;
      }

      this.updateStats(currPlayer, "reset"); 
      this.storage.saveGameStats (this.stats);

      this.player1.turn = 1;
      this.player1.score = 0;

      this.player2.turn = 0;   
      this.player2.score = 0;

      this.board.reset();
      drawBoard(this.player1, this.player2, context);  
   },

   drawLines: function (x, y, i, j) {

      var canvas = document.getElementById('boardCanvas');
      var ctx = canvas.getContext('2d');
      var c1, c2, c3, c4;

      var check;

      if (this.board.hold.length > 0) {
         var a = this.board.hold[0][0];
         var b = this.board.hold[0][1];
         var a1 = a - 50;
         var a2 = a + 50;
         var a3 = b - 50;
         var a4 = b + 50;

         if(a1 === this.board.k[i] && b === this.board.k[j]) {
            check = this.MoveCheck([this.board.k[i],this.board.k[j],a,b]);
            if (check === 0) { 

               ctx.beginPath();
               ctx.moveTo((this.board.k[i]+12),this.board.k[j]);
               ctx.lineTo((a-12),b);
               ctx.linewidth = 6;
               ctx.stroke();
               ctx.closePath();
               this.board.movesMade.push([this.board.k[i],this.board.k[j],a,b]);
               c1 = this.board.k[i];
               c2 = this.board.k[j];
               c3 = a;
               c4 = b;
               this.checkSquare(c1, c2, c3, c4);
           
            }

         } else if(a2 === this.board.k[i] && b === this.board.k[j]) {
          
            check = this.MoveCheck([a,b,this.board.k[i],this.board.k[j]]);
            if(check === 0) {
               ctx.beginPath();
               ctx.moveTo((a+12),b);
               ctx.lineTo((this.board.k[i]-12),this.board.k[j]);
               ctx.linewidth = 6;
               ctx.stroke();
               ctx.closePath();
               this.board.movesMade.push([a,b,this.board.k[i],this.board.k[j]]);
               c1 = a;
               c2 = b;
               c3 = this.board.k[i];
               c4 = this.board.k[j];
               this.checkSquare(c1, c2, c3, c4);
           
            }

         } else {

           if(a3 === this.board.k[j] && a === this.board.k[i]) {

               check = this.MoveCheck([this.board.k[i],this.board.k[j],a,b]);

               if(check === 0) {
                  ctx.beginPath();
                  ctx.moveTo(a,(a3+12));
                  ctx.lineTo(a,(b-12));
                  ctx.linewidth = 6;
                  ctx.stroke();
                  ctx.closePath();
                  this.board.movesMade.push([this.board.k[i],this.board.k[j],a,b]); 
                  c1 = this.board.k[i];
                  c2 = this.board.k[j];
                  c3 = a;
                  c4 = b;
                  this.checkSquare(c1, c2, c3, c4);
            
               }      

           } else if(a4 === this.board.k[j] && a === this.board.k[i]) {

               check = this.MoveCheck([a,b,this.board.k[i],this.board.k[j]]);
               if(check === 0) {
                  ctx.beginPath();
                  ctx.moveTo(a,(b+12));
                  ctx.lineTo(a,(a4-12));
                  ctx.linewidth = 6;
                  ctx.stroke();
                  ctx.closePath();  
                  this.board.movesMade.push([a,b,this.board.k[i],this.board.k[j]]);
                  c1 = a;
                  c2 = b;
                  c3 = this.board.k[i];
                  c4 = this.board.k[j];
                  this.checkSquare(c1, c2, c3, c4);
               
               }
          
            } else { 
               if(this.player1.turn === 1) {
                  this.player1.turn = 0;
                  this.player2.turn = 1;
               } else {
                  this.player1.turn = 1;
                  this.player2.turn = 0;
               } 
            }
        }
        if(check === 1) {
           if(this.player1.turn === 1) {
              this.player1.turn = 0;
              this.player2.turn = 1;
           } else {
              this.player1.turn = 1;
              this.player2.turn = 0;
           }
        } 
        context.beginPath();
        context.moveTo(this.board.hold[0][0], this.board.hold[0][1]);
        context.arc(this.board.hold[0][0], this.board.hold[0][1], 8, 0, 2* Math.PI, true);
        context.lineWidth = 2;
        context.stroke();
        context.fillStyle ='#fef';
        context.fill();
        this.board.hold.splice(0,1);

     } else {
        context.beginPath();
        context.arc(this.board.k[i], this.board.k[j], 8, 0, 2* Math.PI, true);
        context.lineWidth = 2;
        context.stroke();
        context.fillStyle ='#0f0';
        context.fill();
        this.board.hold.push([this.board.k[i],this.board.k[j]]);
        if(this.player1.turn === 1) {
           this.player1.turn = 0;
           this.player2.turn = 1;
        } else {
           this.player1.turn = 1;
           this.player2.turn = 0;
        }

      }
   },

   checkSquare: function (i, j, h1, h2) {
      var cnr1 = 0;
      var cnr2 = 0;
      var choice;
      var sz = this.board.num -1;
      var n = 0;
      var orientation = j - h2;
      var ss1 = [];
      var ss2 = [];
      var a1, a2, a3, a4;
      var s;
      var s1a, s1b, s1c;
      var s2a, s2b, s2c;
      var kk = this.board.k[0];

      if (orientation == 0) {           //the line placed is horizontal
         a1 = j + kk;
         a2 = h2 + kk;
         a3 = j - kk;
         a4 = h2 - kk;

         s = [i,j, h1, h2].toString();

         s1a = [i,j, i, a1].toString();
         s1b = [h1, h2, h1, a2].toString();
         s1c = [i, a1, h1, a2].toString();

         s2a = [i,a3, i, j].toString();
         s2b = [h1, a4, h1, h2].toString();
         s2c = [i, a3, h1, a4].toString(); 

         ss2 = [[i,a3], [h1, a4], [i,j], [h1, h2]];
         ss1 = [[i,j], [h1,h2], [i, a1], [h1, a3]];

      } else {                          //the line placed is vertical
         a1 = i + kk;
         a2 = h1 + kk;
         a3 = i - kk;
         a4 = h1 - kk;

         s = [i,j, h1, h2].toString();
         s1a = [a3,j, i, j].toString();
         s1b = [a3, j, a3, h2].toString();
         s1c = [a3, h2, h1, h2].toString();

         s2a = [i,j, a1, j].toString();
         s2b = [h1, h2, a2, h2].toString();
         s2c = [a1, j, a2, h2].toString();

         ss1 = [[a3,j], [i, j], [a4,h2], [h1, h2]];
         ss2 = [[i,j], [a1,j], [h1, h2], [a2, h2]];

      }

      for(var i = 0; i < this.board.movesMade.length; i++) {
         choice = this.board.movesMade[i].toString();
      
         if(s1a === choice || s1b === choice || s1c === choice || s === choice) {
            cnr1 = cnr1+1;
         }
         if(s2a === choice || s2b === choice || s2c === choice || s === choice) {
            cnr2 = cnr2+1;
         }
      }

      if (cnr1 === 4 && cnr2 === 4 ) {
         this.colourSquare(ss1);
         this.colourSquare(ss2);
         this.board.filledSquares.push(ss1);
         this.board.filledSquares.push(ss2);
         if(this.player1.turn === 1) {
            this.player1.turn = 0;
            this.player2.turn = 1;
         } else {
            this.player1.turn = 1;
            this.player2.turn = 0;
         }
         if(this.board.filledSquares.length === (sz*sz)) {
            this.endgame();
         }
         return 2;
      } else if ((cnr1 === 4) || cnr2 === 4) {
         if (cnr1 == 4) {
            this.colourSquare(ss1);
            this.board.filledSquares.push(ss1);
         } else {
            this.colourSquare(ss2);
            this.board.filledSquares.push(ss2);
         } 
         if(this.player1.turn === 1) {
            this.player1.turn = 0;
            this.player2.turn = 1;
         } else {
            this.player1.turn = 1;
            this.player2.turn = 0;
         }
         if(this.board.filledSquares.length === (sz*sz)) {
            this.endgame();
         }
         return 1;
      }
   
      return 0;       
   },


   endgame: function() {
      if(this.player1.score > this.player2.score) {
         alert(this.player1.name+" is the winner!");
         this.updateStats(this.player1, "win");
         this.updateStats(this.player2, "lose");
      } else {
         alert(this.player2.name+" is the winner!");
         this.updateStats(this.player1, "lose");
         this.updateStats(this.player2, "win");
      }

      this.storage.saveGameStats(this.stats);
   
   },


   MoveCheck: function(x) {
      var h = x.toString();
      var g;
      for(var i = 0; i < this.board.movesMade.length;i++){
         g = this.board.movesMade[i];
         if (h == g)
            return 1;
      }
      return 0;
   },


   updateStats: function (player, result) {
	var playerName = player.name;
        var sc1, sc2, sc3, tt1;

	var playerRecord = {};
	if (this.stats [playerName]) {
	   playerRecord = this.stats [playerName];
	   playerRecord ["total"] ++;
	} else {
           playerRecord ["total"] = 1;
        }
	
        if(!playerRecord["win"]) 
           playerRecord["win"] = 0;
        if(!playerRecord["lose"])
           playerRecord["lose"] = 0;
        if(!playerRecord["reset"])
           playerRecord["reset"] = 0;

        tt1 = playerRecord["total"];
	var stat = playerRecord [result];
			
	if (stat)
	   playerRecord [result] ++;
	else
	   playerRecord [result] = 1;
        

        if (!playerRecord["win"])
           sc1 = 0;
        else
           sc1 = playerRecord["win"];

        if (!playerRecord["lose"])
           sc2 = 0;
        else
           sc2 = playerRecord["lose"];

        if (!playerRecord["reset"])
           sc3 = 0;
        else
           sc3 = playerRecord["reset"];
        
        playerRecord["score"] = (((sc1/tt1)*10) + ((sc2/tt1)*3) + (sc3/tt1));
        	
	this.stats[playerName] = playerRecord;
        addEntry(playerName, playerRecord);
        
   },



   colourSquare: function(ss1) {
      var p1 = ss1[0][0]+10;
      var p2 = ss1[0][1]+10;

      if (this.player1.turn === 1) {
         context.fillStyle = this.player2.colour;
         this.player2.score = this.player2.score + 1;

      } else {
         context.fillStyle = this.player1.colour;
         this.player1.score = this.player1.score+1;

      }
      canvasElem = document.getElementById('boardCanvas');
      context = canvasElem.getContext("2d"); 
      context.fillRect(p1, p2, 30, 30);
      context.stroke();

      context.fillStyle ='white';
      context.fillRect(125, 543, 140, 23);
      context.fillRect(390, 543, 145, 23);

      context.fillStyle ='black';
      context.textAlign = 'left';
      context.font = '20px Calibri'; 
      context.fillText(this.player1.score, 195, 562);

      context.font = '20px Calibri'; 
      context.fillText(this.player2.score, 463, 562);

   },
};