

//game circle class for each position
function gameCircle(ctx, x, y, radius, color, status) {
	//status of the circle (set or unset)
	this.status = status;
	//color of the circle
	this.color = color;
	this.underColor = color;
	this.pNum;
	this.origColor = color;
	this.resetColors = function() {
		this.color = this.origColor;
		this.underColor = this.origColor;	
	}
	this.swapColors = function() {
		var temp = this.color;
		this.color = this.underColor;
		this.underColor = temp;
		this.draw();
	}
	this.highlight = "black";
	this.linewidth = 5;
	//highlight self
	this.hlself = function(color) {
		this.highlight = color;
		this.linewidth = 10;
		this.draw();	
	}
	this.dehlself = function() {
		this.highlight = "#FFFF99";
		this.draw();
		this.highlight = "black";
		this.linewidth = 5;
		this.draw();	
	}
    //draw the circle on the canvas
	this.x = x;
	this.y = y;
	this.radius = radius;
	this.wasHit = function (xHit, yHit) {
		if (xHit > this.x - this.radius && 
		    xHit < this.x + this.radius &&
			yHit > this.y - this.radius &&
			yHit < this.y + this.radius)
			return true;
		return false;	    
	}
	
	this.draw = function () {
		ctx.beginPath();
	    ctx.arc(x, y, radius, 0, Math.PI*2, true);  
        ctx.closePath();
	    ctx.strokeStyle = this.highlight;
	    ctx.lineWidth= this.linewidth;
	    ctx.stroke();
	    ctx.fillStyle = this.color;
        ctx.fill();
	}
	//change the color of the circle
	this.changeColor = function(c) {
		this.color = c;
		this.draw();
	}
	
	//function for creating text when it is provided
	this.writeText = function (text, xText, yText, rotate, font) {
		ctx.save();
		ctx.translate(xText, yText);
		ctx.rotate(rotate);
    	ctx.font = font;
		ctx.fillStyle = "black"
		ctx.fillText(text , 0, 0);
		ctx.restore();
	}
	
	this.isSet = function () {
		if (this.status === "set") {
			return true;
		}
		return false;
	}
	this.changeStatus = function() {
		if (this.status === "set") {
			this.status = "unset";
			return;
		}
		this.status = "set";
	}
	
	//circle draws itself when initialized
	this.draw();

}


//Draw the game board in canvas.
function drawBoard(){
	//getters for each base
    this.getGreenBase = function() {
		return greenBase;
	}
    this.getRedBase = function() {
		return redBase;
	}
    this.getBlueBase = function() {
		return blueBase;
	}
    this.getYellowBase = function() {
		return yellowBase;
	}
	//getters for each home
    this.getGreenHome = function() {
		return greenHome;
	}
    this.getRedHome = function() {
		return redHome;
	}
    this.getBlueHome = function() {
		return blueHome;
	}
    this.getYellowHome = function() {
		return yellowHome;
	}
	//getter for the main path
	this.getPath = function() {
		return path;
	}

	var bt = 44; //distance between circles
	var cRad = 15;
	var cSmall = cRad - 2.5;
	var canvasElem = document.getElementById("boardCanvas");
    var ctx = canvasElem.getContext("2d");
	
	//Draw the background	
	ctx.fillStyle = "#FFFF99";
	ctx.fillRect(0,0, 500, 500);
	
	//inner border
	ctx.fillStyle = "black";
	ctx.lineWidth = 2;
	ctx.strokeRect(5,5,490,490);

	
	//start of green home
    var greenHome = [
		new gameCircle(ctx,470 - bt, 250,cSmall,"Green","unset"),
		new gameCircle(ctx,470 - 2 * bt, 250,cSmall,"Green","unset"),
		new gameCircle(ctx,470 - 3 * bt, 250,cSmall,"Green","unset"),
		new gameCircle(ctx,470 - 4 * bt, 250,cSmall,"Green","unset"),	
	];
	//green home text
	greenHome[0].writeText("a",470 - bt + 7, 250 + 8,-0.5*Math.PI,"bold 25pt Aguafina");
	greenHome[1].writeText("b",470 - 2 * bt + 10, 250 + 8,-0.5*Math.PI,"bold 23pt Aguafina");
	greenHome[2].writeText("c",470 - 3 * bt + 7, 250 + 8,-0.5*Math.PI,"bold 25pt Aguafina");
	greenHome[3].writeText("d",470 - 4 * bt + 10, 250 + 8,-0.5*Math.PI,"bold 23pt Aguafina");
	
	
	//start of Red home
    var redHome = [
		new gameCircle(ctx,30 + bt, 250,cSmall,"Red","unset"),
		new gameCircle(ctx,30 + 2 * bt, 250,cSmall,"Red","unset"),
		new gameCircle(ctx,30 + 3 * bt, 250,cSmall,"Red","unset"),
		new gameCircle(ctx,30 + 4 * bt, 250,cSmall,"Red","unset"),	
	];
	//red home text
	redHome[0].writeText("a",30 + bt - 7, 250 - 8,+0.5*Math.PI,"bold 25pt Aguafina");
	redHome[1].writeText("b",30 + 2 * bt - 10, 250 - 8,+0.5*Math.PI,"bold 23pt Aguafina");
	redHome[2].writeText("c",30 + 3 * bt - 7, 250 - 8,+0.5*Math.PI,"bold 25pt Aguafina");
	redHome[3].writeText("d",30 + 4 * bt - 10, 250 - 8,+0.5*Math.PI,"bold 23pt Aguafina");

	//start of blue home
    var blueHome = [
		new gameCircle(ctx,250, 30 + bt,cSmall,"Blue","unset"),
		new gameCircle(ctx,250, 30 + 2 * bt,cSmall,"Blue","unset"),
		new gameCircle(ctx,250, 30 + 3 * bt,cSmall,"Blue","unset"),
		new gameCircle(ctx,250, 30 + 4 * bt,cSmall,"Blue","unset"),	
	];
	//blue home text
	blueHome[0].writeText("a",250 + 8, 30 + bt - 8,+1*Math.PI,"bold 25pt Aguafina");
	blueHome[1].writeText("b",250 + 8, 30 + 2 * bt - 10,+1*Math.PI,"bold 23pt Aguafina");
	blueHome[2].writeText("c",250 + 8, 30 + 3 * bt - 8,+1*Math.PI,"bold 25pt Aguafina");
	blueHome[3].writeText("d",250 + 8, 30 + 4 * bt - 10,+1*Math.PI,"bold 23pt Aguafina");
	
	//start of yellow home
    var yellowHome = [
		new gameCircle(ctx,250, 470 - bt,cSmall,"Yellow","unset"),
		new gameCircle(ctx,250, 470 - 2 * bt,cSmall,"Yellow","unset"),
		new gameCircle(ctx,250, 470 - 3 * bt,cSmall,"Yellow","unset"),
		new gameCircle(ctx,250, 470 - 4 * bt,cSmall,"Yellow","unset"),	
	];
	//yellow home text
	yellowHome[0].writeText("a",250 - 8, 470 - bt + 8,0,"bold 25pt Aguafina");
	yellowHome[1].writeText("b",250 - 8, 470 - 2 * bt + 10,0,"bold 23pt Aguafina");
	yellowHome[2].writeText("c",250 - 8, 470 - 3 * bt + 8,0,"bold 25pt Aguafina");
	yellowHome[3].writeText("d",250 - 8, 470 - 4 * bt + 10,0,"bold 23pt Aguafina");
	
	//green base
	var greenBase = [
    	new gameCircle(ctx,470,470,cRad,"Green","set"),
		new gameCircle(ctx,470, 470 - bt,cRad,"Green","set"),
		new gameCircle(ctx,470 - bt, 470,cRad,"Green","set"),
		new gameCircle(ctx,470 - bt, 470 - bt,cRad,"Green","set")
	];

	//Red base
	var redBase = [
		new gameCircle(ctx,30, 30,cRad,"Red","set"),
		new gameCircle(ctx,30 + bt, 30,cRad,"Red","set"),
		new gameCircle(ctx,30, 30 + bt,cRad,"Red","set"),
		new gameCircle(ctx,30 + bt, 30 + bt,cRad,"Red","set")
	];
	
	//blue base
	var blueBase = [
		new gameCircle(ctx,470, 30,cRad,"Blue","set"),
		new gameCircle(ctx,470, 30 + bt,cRad,"Blue","set"),
		new gameCircle(ctx,470 - bt, 30,cRad,"Blue","set"),
		new gameCircle(ctx,470 - bt, 30 + bt,cRad,"Blue","set")
    ];
	
	//yellow base
	var yellowBase = [
		new gameCircle(ctx,30, 470,cRad,"Yellow","set"),
		new gameCircle(ctx,30, 470 - bt,cRad,"Yellow","set"),
		new gameCircle(ctx,30 + bt, 470,cRad,"Yellow","set"),
		new gameCircle(ctx,30 + bt, 470 - bt,cRad,"Yellow","set")
	];
	
	//all the circles on the path around the board
	
	var path = {
		"topLeft" :   [new gameCircle(ctx,30, 250 - bt,cRad,"#FF6633","unset"),
		               new gameCircle(ctx,30 + bt, 250 - bt,cRad,"white","unset"),
		               new gameCircle(ctx,30 + 2 * bt, 250 - bt,cRad,"white","unset"),
					   new gameCircle(ctx,30 +3 * bt, 250 - bt,cRad,"white","unset"),
					   new gameCircle(ctx,30 + 4 * bt, 250 - bt,cRad,"white","unset"),
					   new gameCircle(ctx,30 + 4 * bt, 250 - 2 * bt,cRad,"white","unset"),
					   new gameCircle(ctx,30 + 4 * bt, 250 - 3 * bt,cRad,"white","unset"),
					   new gameCircle(ctx,30 + 4 * bt, 250 - 4 * bt,cRad,"white","unset"),
					   new gameCircle(ctx,250 - bt, 30,cRad,"white","unset"),
					   new gameCircle(ctx,250, 30,cRad,"white","unset")	
	                   ],
		"topRight" :  [new gameCircle(ctx,250 + bt, 30,cRad,"#0099FF","unset"),
		               new gameCircle(ctx,250 + bt, 30 + bt,cRad,"white","unset"),
		               new gameCircle(ctx,250 + bt, 30 + 2 * bt,cRad,"white","unset"),
					   new gameCircle(ctx,250 + bt, 30 + 3 * bt,cRad,"white","unset"),
					   new gameCircle(ctx,250 + bt, 30 + 4 * bt,cRad,"white","unset"),
					   new gameCircle(ctx,250 + 2 * bt, 30 + 4 * bt,cRad,"white","unset"),
					   new gameCircle(ctx,250 + 3 * bt, 30 + 4 * bt,cRad,"white","unset"),
					   new gameCircle(ctx,250 + 4 * bt, 30 + 4 * bt,cRad,"white","unset"),
					   new gameCircle(ctx,470, 250 - bt,cRad,"white","unset"),
					   new gameCircle(ctx,470, 250,cRad,"white","unset")	
					  ],
	   "bottomRight" :[new gameCircle(ctx,470, 250 + bt,cRad,"#66CC33","unset"),
	                   new gameCircle(ctx,470 - bt, 250 + bt,cRad,"white","unset"),
		               new gameCircle(ctx,470 - 2 * bt, 250 + bt,cRad,"white","unset"),
					   new gameCircle(ctx,470 - 3 * bt, 250 + bt,cRad,"white","unset"),
					   new gameCircle(ctx,470 - 4 * bt, 250 + bt,cRad,"white","unset"),
					   new gameCircle(ctx,470 - 4 * bt, 250 + 2 * bt,cRad,"white","unset"),
					   new gameCircle(ctx,470 - 4 * bt, 250 + 3 * bt,cRad,"white","unset"),
					   new gameCircle(ctx,470 - 4 * bt, 250 + 4 * bt,cRad,"white","unset"),
					   new gameCircle(ctx,250 + bt, 470,cRad,"white","unset"),
					   new gameCircle(ctx,250, 470,cRad,"white","unset")	
					  ],
		"bottomLeft" : [new gameCircle(ctx,250 - bt, 470,cRad,"#FFFF66","unset"),
		                new gameCircle(ctx,250 - bt, 470 - bt,cRad,"white","unset"),
		                new gameCircle(ctx,250 - bt, 470 - 2 * bt,cRad,"white","unset"),
						new gameCircle(ctx,250 - bt, 470 - 3 * bt,cRad,"white","unset"),
						new gameCircle(ctx,250 - bt, 470 - 4 * bt,cRad,"white","unset"),
						new gameCircle(ctx,250 - 2 * bt, 470 - 4 * bt,cRad,"white","unset"),
						new gameCircle(ctx,250 - 3 * bt, 470 - 4 * bt,cRad,"white","unset"),
						new gameCircle(ctx,250 - 4 * bt, 470 - 4 * bt,cRad,"white","unset"),
						new gameCircle(ctx,30, 250 + bt,cRad,"white","unset"),
						new gameCircle(ctx,30, 250,cRad,"white","unset")
					   ]
	
	};
	//path.bottomLeft.c1.changeColor("purple");
	
	//parts of game name
	ctx.save();
	ctx.translate(250 - 125 - 60, 250 - 125 + 20 );
    ctx.font = "bold 25pt Aguafina Script";
	ctx.fillStyle = "black"
	ctx.fillText('Mensch' , 0, 0);
	ctx.restore();
	
	ctx.save();
	ctx.translate(250 + 125 - 20, 250 - 125 + 20 );
    ctx.font = "bold 25pt Aguafina Script";
	ctx.fillStyle = "black"
	ctx.fillText('ärgere' , 0, 0);
	ctx.restore();
	
	ctx.save();
	ctx.translate(250 - 125 - 50, 250 + 125 );
    ctx.font = "bold 25pt Aguafina Script";
	ctx.fillStyle = "black"
	ctx.fillText('Dich' , 0, 0);
	ctx.restore();
	
	ctx.save();
	ctx.translate(250 + 125 - 20, 250 + 125 );
    ctx.font = "bold 25pt Aguafina Script";
	ctx.fillStyle = "black"
	ctx.fillText('nicht' , 0, 0);
	ctx.restore();
	

}