

function game() {
	loadFonts();

	var canvasElem = document.getElementById('boardCanvas');
	
	this.state = "Adding Players";
	
	var pm = new playerManager();
	pm.populateRemainingColors();
	
	//clear the playerName text field when user clicks on it
	var playerName = document.getElementById("playerName");
	playerName.addEventListener("click",function() { playerName.value = ""},false);	
	
	var btnSubmit = document.getElementById("btnSubmit");
	btnSubmit.addEventListener("click",function() {	
			var name = document.getElementById("playerName").value;
			var color = document.getElementById("colorList").value;
			pm.addPlayer(name, color);
			
		},false
	);

    var divGameState = document.getElementById("gameState");
	var divGameTurn = document.getElementById("gameTurn");
	var divRollButton = document.getElementById("divBtnRoll");
	var stateString = "State: " + this.state + "<br></br>";
	divGameState.innerHTML = stateString;
    var btnStart = document.getElementById("btnStart");
	
	var currTurn = pm.getTurn();
	var btnRoll;
	
	//draw the game board and set default positions
	var board = new drawBoard();

	var gm = new gameManager();
	gm.init(board);
	
	var btnReset = document.getElementById("btnReset");
	btnReset.addEventListener("click",function() { location.reload();
	 },false);	
	
	canvasElem.addEventListener("click",function(e){board_click(e,board,gm, pm)},false);
	
	
	gm.rollsRemaining = 3;
	btnStart.addEventListener("click", function() {
			currTurn = pm.getTurn();
			if (currTurn === undefined || pm.getNum() < 2)
				alert("You must have 2-4 players to start a game");
			else {
				this.state = "Game in Progress";
				stateString = "State: " + this.state + "<br></br>";
				var strRoll = "<button type = 'button' class = 'button' id = 'btnRoll'>Roll</button>";
				var strCurr = "Current turn: " + "<" + currTurn + ">" + currTurn + "</" + currTurn + ">";
				divGameState.innerHTML = stateString;
				divGameTurn.innerHTML = strCurr ;
			    divRollButton.innerHTML = strRoll;
					                    
				btnRoll = document.getElementById("btnRoll");
				btnRoll.addEventListener("click", function() {
					if (gm.state == "select") {
						alert("Cannot roll again until you move a piece");
					}
					else {
						gm.roll();
						currTurn = pm.getTurn();
						if (pm.pass) {
							//alert("passing");
							pm.passTurn();
							currTurn = pm.getTurn();
							pm.pass = false;
						}
                        //alert(rollsRemaining + " " + currTurn);
						if (gm.allInBase(currTurn)) {
							gm.state = "takeOut";
							gm.rollsRemaining--;

							if (gm.rollsRemaining == 0) {
								gm.rollsRemaining = 3;
								pm.pass = true;
								
							}
							
						}
						else {
							//there is at least one piece on the path
							gm.state = "select";
							//gm.move(currTurn);
						    updateGameTurn(currTurn);
						}
						strCurr = "Current turn: " + "<" + currTurn + ">" + currTurn + "</" + currTurn + ">";
						divGameTurn.innerHTML = strCurr + "<br></br> Rolled: " + gm.getRoll();
						
					}

									
					}, false
				);
			}
		},false
	);

	//b.getPath().bottomLeft.c1.changeColor("purple");
	
	
	//var banner = new bannerControl();
	//banner.displayWin("Blue");
	//banner.clear();
	
	

	
	//var btnRoll = document.getElementById("btnRoll");

	

}
function updateGameTurn(currTurn) {
	var divGameTurn = document.getElementById("gameTurn");
	var strCurr = "Current turn: " + "<" + currTurn + ">" + currTurn + "</" + currTurn + ">";
	divGameTurn.innerHTML = strCurr;
}

function loadFonts() {
	
	//get custom font from web used by game board
	var link = document.createElement('link');
	link.rel = 'stylesheet';
	link.type = 'text/css';
	link.href = 'http://fonts.googleapis.com/css?family=Aguafina+Script';
	document.getElementsByTagName('head')[0].appendChild(link);
}


function board_click(e,b, gm, pm) {
	var x;
	var y;
	x = e.layerX;
	y = e.layerY;

	//These functions search until they find the object the user clicked on.
	//Once the object is found, the search is over and this function returns
    var gB = b.getGreenBase();
    for (var i = 0; i < gB.length; i++) {
		if (gB[i].wasHit(x,y)) {
			if (pm.getTurn() == "Green" && gm.getRoll() == 6 && gm.state == "takeOut") { 
				gm.takeOutOfBase("Green",i);
				pm.passTurn();
				pm.pass = false;
				gm.rollsRemaining = 3;
				updateGameTurn(pm.getTurn());
			}
			else if (pm.getTurn() == "Green" && gm.getRoll() == 6 && gm.state == "select" && b.getPath().bottomRight[0].color != "Green" && gB[i].color != "white") {
				gm.takeOutOfBase("Green",i);
				pm.passTurn();
				pm.pass = false;
				gm.rollsRemaining = 3;
				updateGameTurn(pm.getTurn());	
			}
			
			//alert(gB[i].color + " " + i);
			return;
		}
	}
	var yB = b.getYellowBase();
    for (var i = 0; i < yB.length; i++) {
		if (yB[i].wasHit(x,y)) {
			if (pm.getTurn() == "Yellow" && gm.getRoll() == 6 && gm.state == "takeOut") {
				gm.takeOutOfBase("Yellow",i);
				pm.passTurn();
				pm.pass = false;
				gm.rollsRemaining = 3;
				updateGameTurn(pm.getTurn());
				//alert(yB[i].color + " " + i);
			}
			else if (pm.getTurn() == "Yellow" && gm.getRoll() == 6 && gm.state == "select" && b.getPath().bottomLeft[0].color != "Yellow" && yB[i].color != "white") {
				gm.takeOutOfBase("Yellow",i);
				pm.passTurn();
				pm.pass = false;
				gm.rollsRemaining = 3;
				updateGameTurn(pm.getTurn());	
			}
			return;
		}
	}
    var rB = b.getRedBase();
    for (var i = 0; i < rB.length; i++) {
		if (rB[i].wasHit(x,y)) {
			//alert(pm.getTurn() + " " + gm.getRoll());
			if (pm.getTurn() == "Red" && gm.getRoll() == 6 && gm.state == "takeOut") {
				gm.takeOutOfBase("Red",i);
				pm.passTurn();
				pm.pass = false;
				gm.rollsRemaining = 3;
				updateGameTurn(pm.getTurn());
			}
			else if (pm.getTurn() == "Red" && gm.getRoll() == 6 && gm.state == "select" && b.getPath().topLeft[0].color != "Red"  && rB[i].color != "white") {
				gm.takeOutOfBase("Red",i);
				pm.passTurn();
				pm.pass = false;
				gm.rollsRemaining = 3;
				updateGameTurn(pm.getTurn());	
			}
			//alert(rB[i].color + " " + i);
			return;
		}
	}
    var bB = b.getBlueBase();
    for (var i = 0; i < bB.length; i++) {
		if (bB[i].wasHit(x,y)) {
			if (pm.getTurn() == "Blue" && gm.getRoll() == 6 && gm.state == "takeOut") {
				gm.takeOutOfBase("Blue",i);
				pm.passTurn();
				pm.pass = false;
				gm.rollsRemaining = 3;
				updateGameTurn(pm.getTurn());
			}
			else if (pm.getTurn() == "Blue" && gm.getRoll() == 6 && gm.state == "select" && b.getPath().topRight[0].color != "Blue" && bB[i].color != "white") {
				gm.takeOutOfBase("Blue",i);
				pm.passTurn();
				pm.pass = false;
				gm.rollsRemaining = 3;
				updateGameTurn(pm.getTurn());	
			}
			//alert(bB[i].color + " " + i);
			return;
		}
	}
    var gH = b.getGreenHome();
    for (var i = 0; i < gH.length; i++) {
		if (gH[i].wasHit(x,y)) {
			if (gH[i].highlight == "Orange" && gm.state == "move") {
				gH[i].dehlself();
				gm.move(b.getPath().topRight[gm.origPos],gH[i]);
				gm.green.inHome[i] = 1;
				if (gm.green.checkAllHome()) {
					var banner = new bannerControl();
					banner.displayWin("Green");	
				}
				pm.passTurn();
				pm.pass = false;
				gm.rollsRemaining = 3;
				updateGameTurn(pm.getTurn());
			}
			//alert(gH[i].color + " " + i);
			return;
		}
	}
	var yH = b.getYellowHome();
    for (var i = 0; i < yH.length; i++) {
		if (yH[i].wasHit(x,y)) {
			if (yH[i].highlight == "Orange" && gm.state == "move") {
				yH[i].dehlself();
				gm.move(b.getPath().bottomRight[gm.origPos],yH[i]);
				gm.yellow.inHome[i] = 1;
				if (gm.yellow.checkAllHome())
					var banner = new bannerControl();
					banner.displayWin("Yellow");									
				pm.passTurn();
				pm.pass = false;
				gm.rollsRemaining = 3;
				updateGameTurn(pm.getTurn());
			}
			//alert(yH[i].color + " " + i);
			return;
		}
	}
    var rH = b.getRedHome();
    for (var i = 0; i < rH.length; i++) {
		if (rH[i].wasHit(x,y)) {
			if (rH[i].highlight == "Orange" && gm.state == "move") {
				rH[i].dehlself();
				gm.move(b.getPath().bottomLeft[gm.origPos],rH[i]);
				gm.red.inHome[i] = 1;
				if (gm.red.checkAllHome())
					var banner = new bannerControl();
					banner.displayWin("Red");					
				pm.passTurn();
				pm.pass = false;
				gm.rollsRemaining = 3;
				updateGameTurn(pm.getTurn());
			}
			//alert(rH[i].color + " " + i);
			return;
		}
	}
    var bH = b.getBlueHome();
    for (var i = 0; i < bH.length; i++) {
		if (bH[i].wasHit(x,y)) {
			if (bH[i].highlight == "Orange" && gm.state == "move") {
				bH[i].dehlself();
				gm.move(b.getPath().topLeft[gm.origPos],bH[i]);
				gm.blue.inHome[i] = 1;
				if (gm.blue.checkAllHome())
					var banner = new bannerControl();
					banner.displayWin("Blue");	
				pm.pass = false;
				gm.rollsRemaining = 3;
				updateGameTurn(pm.getTurn());
			}
			//alert(bH[i].color + " " + i);
			return;
		}
	}	
	var path = b.getPath();
	var quadChange = 0;
	for (var locations in path) {
		var circles = path[locations];
		var quads = ["topLeft","topRight","bottomRight","bottomLeft"];
		var count = 0;
		for (circle in circles) {
        	if (circles[circle].wasHit(x,y)) {
				if (circles[circle].color == pm.getTurn() && gm.state == "select") {
					if (pm.getTurn() == "Red") {
						var rtnQuad = gm.red.selectAvailable(b,gm.getRoll(), circles[circle].pNum);
						if (rtnQuad != "none") {
							gm.selPos = count + gm.getRoll();
							gm.selPos %= 10;
							gm.selQuad = rtnQuad;
							gm.origPos = count;
							gm.origQuad = gm.red.quadrant[circles[circle].pNum];
						}
						//alert("selected position: " + gm.selPos + " " + gm.selQuad + " orig position: " + gm.origPos + " " + gm.origQuad);
					}
					else if(pm.getTurn() == "Blue") {
						var rtnQuad = gm.blue.selectAvailable(b,gm.getRoll(), circles[circle].pNum);
						if (rtnQuad != "none") {
							gm.selPos = count + gm.getRoll();
							gm.selPos %= 10;
							gm.selQuad = rtnQuad;
							gm.origPos = count;
							gm.origQuad = gm.blue.quadrant[circles[circle].pNum];
						}
					}
					else if (pm.getTurn() == "Green") {
						var rtnQuad = gm.green.selectAvailable(b,gm.getRoll(), circles[circle].pNum);
						if (rtnQuad != "none") {					
							gm.selPos = count + gm.getRoll();
							gm.selPos %= 10;						
							gm.selQuad = rtnQuad;
							gm.origPos = count;
							gm.origQuad = gm.green.quadrant[circles[circle].pNum];
						}
					}
					else { // its yellow
						var rtnQuad = gm.yellow.selectAvailable(b,gm.getRoll(), circles[circle].pNum);
						if (rtnQuad != "none") {
							gm.selPos = count + gm.getRoll();
							gm.selPos %= 10;
							gm.selQuad = rtnQuad;
							gm.origPos = count;
							gm.origQuad = gm.yellow.quadrant[circles[circle].pNum];
						}
					}
					gm.state = "move";
				}
				else if (gm.selPos == count && gm.selQuad == quads[quadChange] && gm.state == "move") {
					//alert("hi");
					//dehighlight the selected position
					circles[circle].dehlself();
					//swap the circles and update the info in the corresponding colors gm
					if (gm.origQuad == "topLeft" && gm.selQuad == "topLeft") {
						gm.move(path.topLeft[gm.origPos], path.topLeft[gm.selPos]);
					}
					else if (gm.origQuad == "bottomLeft" && gm.selQuad == "topLeft") {
						gm.move(path.bottomLeft[gm.origPos], path.topLeft[gm.selPos]);
					}
					else if (gm.origQuad == "topRight" && gm.selQuad == "topRight") {
						gm.move(path.topRight[gm.origPos], path.topRight[gm.selPos]);
					}
					else if (gm.origQuad == "topLeft" && gm.selQuad == "topRight") {
						gm.move(path.topLeft[gm.origPos], path.topRight[gm.selPos]);
					}
					else if (gm.origQuad == "bottomRight" && gm.selQuad == "bottomRight") {
						gm.move(path.bottomRight[gm.origPos], path.bottomRight[gm.selPos]);
					}					
					else if (gm.origQuad == "topRight" && gm.selQuad == "bottomRight") {
						gm.move(path.topRight[gm.origPos], path.bottomRight[gm.selPos]);
					}
					else if (gm.origQuad == "bottomLeft" && gm.selQuad == "bottomLeft") {
						gm.move(path.bottomLeft[gm.origPos], path.bottomLeft[gm.selPos]);
					}
					else if (gm.origQuad == "bottomRight" && gm.selQuad == "bottomLeft") {
						gm.move(path.bottomRight[gm.origPos], path.bottomLeft[gm.selPos]);
					}
					pm.passTurn();
					pm.pass = false;
					gm.rollsRemaining = 3;
					updateGameTurn(pm.getTurn());
															
				}


				return;
			}
			count++;
		}
		quadChange++;
		quadChange %= 4;
		count = 0;
	}

	
}


function bannerControl() {
	
	var banner = document.getElementById('bannerCanvas');

	var ctx2 = banner.getContext('2d');
	
	this.clear = function () {
		// Store the current transformation matrix
		ctx2.save();

		// Use the identity matrix while clearing the canvas
		ctx2.setTransform(1, 0, 0, 1, 0, 0);
		ctx2.clearRect(0, 0, banner.width, banner.height);

		// Restore the transform
		ctx2.restore();
		banner.width = 0;
		banner.height = 0;
	}
	this.displayWin = function(color) {
		banner.width = 500;
		banner.height = 500;
		tx = banner.width / 2;
		ty = banner.height / 2;
		if (color == "Blue") {
			ctx2.fillStyle = "rgba(0, 0, 200, 0.7)";
		}
		else if (color == "Green") {
			ctx2.fillStyle = "rgba(0, 200, 0, 0.7)";
		}
		else if (color == "Red") {
			ctx2.fillStyle = "rgba(200, 0, 0, 0.7)";	
		}
		else if (color == "Yellow") {
			ctx2.fillStyle = "rgba(255, 255, 0, 0.7)";
		}
		ctx2.fillRect(10,180, 500, 150);
	    
		ctx2.save();
		ctx2.textAlign='center';
    	ctx2.font = "40pt Aguafina Script";
		ctx2.fillStyle = "black"
		ctx2.fillText(color + " player wins!!!" , tx, ty+ 15);
		ctx2.restore();
	
		ctx2.drawImage(banner,0,0);
	}
	

}