function fourPieces(input,quadrant) {
	this.pieces = input;
	this.quadrant = [quadrant,quadrant,quadrant,quadrant];
	this.spot = [0,0,0,0];
	this.inBase = [1,1,1,1]; // 1 means the piece is in base
	this.inHome = [0,0,0,0]; // 0 means the piece is not in home
	this.changePiece = function(pNum, circle) {
		circle.swapColors();
		circle.changeColor(this.pieces[pNum].color);
		this.pieces[pNum].changeColor("white");
		this.pieces[pNum].changeStatus();
		circle.pNum = pNum;
		circle.changeStatus();
		this.inBase[pNum] = 0;
	}
	this.checkAllBase = function() {
		for (var i = 0; i < 4; i++)
			if (this.inBase[i] == 0)
				return false;
		return true;	
	}
	this.checkAllHome = function() {
		for (var i = 0; i < 4; i++)
			if (this.inHome[i] == 0)
				return false;
		return true;	
	}
	this.selectAvailable = function(board,rollNum,pieceNum) {
		var circle;
		var place;
		//alert("rolled: " + rollNum + " pieceNum: " + pieceNum + " quad of pieceNum: " + this.quadrant[pieceNum] + " new spot: " + (this.spot[pieceNum] + rollNum));
		if (this.quadrant[pieceNum] == "topLeft" && (this.spot[pieceNum] + rollNum) < 10) {
			circle = board.getPath().topLeft[this.spot[pieceNum] + rollNum];
			if (board.getPath().topLeft[this.spot[pieceNum]].color == circle.color) {
				return "none";	
			}
			this.spot[pieceNum] += rollNum;
			circle.hlself("Orange"); 
			return "topLeft";  //returning the quadrant of the highlighted circle
		}
		else if (this.quadrant[pieceNum] == "topLeft" && (this.spot[pieceNum] + rollNum) >= 10) {
			place = this.spot[pieceNum] + rollNum;
			place %= 10;
			if (board.getPath().topLeft[this.spot[pieceNum]].color == "Blue") {
				// try go into the home	
				if (place >= 5) {
					return "none";
				}
				else if (this.inHome[place] == 0) {
					circle = board.getBlueHome()[place];
					circle.hlself("Orange");
					this.spot[pieceNum] = place;
					return "home";
				}
			}
			else {
				circle = board.getPath().topRight[place];
				if (board.getPath().topLeft[this.spot[pieceNum]].color == circle.color) {
					return "none";	
				}
				circle.hlself("Orange");
				this.spot[pieceNum] = place;
				return "topRight";
			}

		}
		else if (this.quadrant[pieceNum] == "topRight" && (this.spot[pieceNum] + rollNum) < 10) {			
			circle = board.getPath().topRight[this.spot[pieceNum] + rollNum];
			if (board.getPath().topRight[this.spot[pieceNum]].color == circle.color) {
				return "none";	
			}
			circle.hlself("Orange"); 
			this.spot[pieceNum] += rollNum;
			return "topRight";
		}	
		else if (this.quadrant[pieceNum] == "topRight" && (this.spot[pieceNum] + rollNum) >= 10) {
			place = this.spot[pieceNum] + rollNum;
			place %= 10;
			if (board.getPath().topRight[this.spot[pieceNum]].color == "Green") {
				// try go into the home
				if (place >= 5) {
					return "none";
				}
				else if (this.inHome[place] == 0) {
					circle = board.getGreenHome()[place];
					circle.hlself("Orange");
					this.spot[pieceNum] = place;
					return "home";
				}	
			}
			else {
				circle = board.getPath().bottomRight[place];
				if (board.getPath().topRight[this.spot[pieceNum]].color == circle.color) {
					return "none";	
				}
				circle.hlself("Orange");
				this.spot[pieceNum] = place; 
				return "bottomRight";
			}

		}	
		else if (this.quadrant[pieceNum] == "bottomRight" && (this.spot[pieceNum] + rollNum) < 10) {
			circle = board.getPath().bottomRight[this.spot[pieceNum] + rollNum];
			if (board.getPath().bottomRight[this.spot[pieceNum]].color == circle.color) {
				return "none";	
			}
			circle.hlself("Orange"); 
			this.spot[pieceNum] += rollNum;
			return "bottomRight";
		}	
		else if (this.quadrant[pieceNum] == "bottomRight" && (this.spot[pieceNum] + rollNum) >= 10) {
			place = this.spot[pieceNum] + rollNum;
			place %= 10;	
			if (board.getPath().bottomRight[this.spot[pieceNum]].color == "Yellow") {
				// try go into the home	
				if (place >= 5) {
					return "none";
				}
				else if (this.inHome[place] == 0) {
					circle = board.getYellowHome()[place];
					circle.hlself("Orange"); 
					this.spot[pieceNum] = place;
					return "home";					
				}
			}		
			else { 
				circle = board.getPath().bottomLeft[place];
				if (board.getPath().bottomRight[this.spot[pieceNum]].color == circle.color) {
					return "none";	
				}
				circle.hlself("Orange"); 
				this.spot[pieceNum] = place;
				return "bottomLeft";
			}
		}	
		else if (this.quadrant[pieceNum] == "bottomLeft" && (this.spot[pieceNum] + rollNum) < 10) {
			circle = board.getPath().bottomLeft[this.spot[pieceNum] + rollNum];
			if (board.getPath().bottomLeft[this.spot[pieceNum]].color == circle.color) {
				return "none";	
			}
			circle.hlself("Orange"); 
			this.spot[pieceNum] += rollNum;
			return "bottomLeft";
		}
		else if (this.quadrant[pieceNum] == "bottomLeft" && (this.spot[pieceNum] + rollNum) >= 10) {
			place = this.spot[pieceNum] + rollNum;
			place %= 10;
			if (board.getPath().bottomLeft[this.spot[pieceNum]].color == "Red") {
				// try go into the home	
				if (place >= 5) {
					return "none";
				}
				else if (this.inHome[place] == 0) {
					circle = board.getRedHome()[place];
					circle.hlself("Orange"); 
					this.spot[pieceNum] = place;
					return "home";
				}
			}
			else {
				circle = board.getPath().topLeft[place];
				if (board.getPath().bottomLeft[this.spot[pieceNum]].color == circle.color) {
					return "none";	
				}
				circle.hlself("Orange"); 
				this.spot[pieceNum] = place;
				return "topLeft";
			}
		}
			
	}
	
}



function getRand(num) {
	return Math.floor(Math.random()*num + 1)	
}
function gameManager() {
    this.rollsRemaining;
	this.red;
	this.green;
	this.blue;
	this.yellow;
	this.board;
	this.rollNum;
	this.state;
	
	this.origPos;
	this.origQuad;
	this.selPos;
	this.selQuad;
	
	this.init = function (board) {
		this.board = board;
		this.red = new fourPieces(board.getRedBase(), "topLeft");
		this.green = new fourPieces(board.getGreenBase(), "bottomRight");
		this.blue = new fourPieces(board.getBlueBase(), "topRight");
		this.yellow = new fourPieces(board.getYellowBase(), "bottomLeft");
		
	}
	this.roll = function() {
		this.rollNum = getRand(6);
		
	}
	this.getRoll = function() {
		return this.rollNum;
	}
	this.takeOutOfBase = function(color,num) {
		this.state = "takeOut";
		if (color == "Red") {
			var hotspot = this.board.getPath().topLeft[0];	
			//check to see what color hotspot currently is
			if (hotspot.color == "Green" || hotspot.color == "Blue" || hotspot.color == "Yellow")
				this.sendToBase(hotspot);
				
			this.red.changePiece(num, hotspot);
			return;								
		}
		if (color == "Green") {
			var hotspot = this.board.getPath().bottomRight[0];	
			//check to see what color hotspot currently is
			if (hotspot.color == "Red" || hotspot.color == "Blue" || hotspot.color == "Yellow")
				this.sendToBase(hotspot);
				
			this.green.changePiece(num, hotspot);	
			return;	
		}
		if (color == "Blue") {
			var hotspot = this.board.getPath().topRight[0];	
			//check to see what color hotspot currently is
			if (hotspot.color == "Green" || hotspot.color == "Red" || hotspot.color == "Yellow")
				this.sendToBase(hotspot);
				
			this.blue.changePiece(num, hotspot);
			return;			
		}
		if (color == "Yellow") {
			var hotspot = this.board.getPath().bottomLeft[0];	
			//check to see what color hotspot currently is
			if (hotspot.color == "Green" || hotspot.color == "Blue" || hotspot.color == "Red")
				this.sendToBase(hotspot);
				
			this.yellow.changePiece(num, hotspot);
			return;			
		}
		
	}
	this.allInBase = function(color) {
		if (color == "Red") {
			if (this.red.checkAllBase())
				return true;
			return false;	
		}
		if (color == "Green") {
			if (this.green.checkAllBase())
				return true;
			return false;				
		}
		if (color == "Blue") {
			if (this.blue.checkAllBase())
				return true;
			return false;				
		}
		if (color == "Yellow") {
			if (this.yellow.checkAllBase())
				return true;
			return false;				
		}
	}
	this.sendToBase = function(circle) {
		var baseElem;
		if (circle.color == "Red") {
			baseElem = this.board.getRedBase()[circle.pNum];
			baseElem.changeColor(circle.color);
			circle.resetColors();
			baseElem.pNum = circle.pNum;
			circle.pNum = "";
			circle.changeStatus();
			this.red.inBase[baseElem.pNum] = 1;
			this.red.quadrant[baseElem.pNum] = "topLeft";
			this.red.spot[baseElem.pNum] = 0;
			return;
		}
		else if (circle.color == "Blue") {
			baseElem = this.board.getBlueBase()[circle.pNum];
			baseElem.changeColor(circle.color);
			circle.resetColors();
			baseElem.pNum = circle.pNum;
			circle.pNum = "";
			circle.changeStatus();
			this.blue.inBase[baseElem.pNum] = 1;
			this.blue.quadrant[baseElem.pNum] = "topRight";
			this.blue.spot[baseElem.pNum] = 0;
			return;	
		}
		else if (circle.color == "Green") {
			baseElem = this.board.getGreenBase()[circle.pNum];
			baseElem.changeColor(circle.color);
			circle.resetColors();
			baseElem.pNum = circle.pNum;
			circle.pNum = "";
			circle.changeStatus();
			this.green.inBase[baseElem.pNum] = 1;
			this.green.quadrant[baseElem.pNum] = "bottomRight";
			this.green.spot[baseElem.pNum] = 0;
			return;	
		}
		else if (circle.color == "Yellow") {
			baseElem = this.board.getYellowBase()[circle.pNum];
			baseElem.changeColor(circle.color);
			circle.resetColors();
			baseElem.pNum = circle.pNum;
			circle.pNum = "";
			circle.changeStatus();
			this.yellow.inBase[baseElem.pNum] = 1;
			this.yellow.quadrant[baseElem.pNum] = "bottomLeft";
			this.yellow.spot[baseElem.pNum] = 0;
			return;	
		}

	}
	
	this.move = function(source, dest) {
		if (dest.isSet()) {
			this.sendToBase(dest);	
		}
		dest.changeColor(source.color);
		source.changeStatus();
		dest.changeStatus();
		//alert(source.color);
		if (source.color == "Red") {
			this.red.spot[source.pNum] = this.selPos;
			this.red.quadrant[source.pNum] = this.selQuad;

		}
		else if (source.color == "Blue") {
			this.blue.spot[source.pNum] = this.selPos;
			this.blue.quadrant[source.pNum] = this.selQuad;
		}
		else if (source.color == "Green") {
			this.green.spot[source.pNum] = this.selPos;
			this.green.quadrant[source.pNum] = this.selQuad;
		}
		else if (source.color == "Yellow") {
			this.yellow.spot[source.pNum] = this.selPos;
			this.yellow.quadrant[source.pNum] = this.selQuad;			
		}
		source.swapColors();
		dest.pNum = source.pNum;
		source.pNum = "";
		source.resetColors();
		
	}
	
}