/*
 * Game Manager
 */
function Game() {	
    this.playerCnt = 2;
    this.currentPlayer = 0;
    this.plays = 0;
    this.disc = null;
    this.players = new Array();
    this.board = new Board();
    this.row = new Array();
    
// turn management    
    this.nextTurn = function() {
        this.plays++;
        this.currentPlayer = this.players[this.plays%this.playerCnt];
        return this.createDisc();
    };

// check if winning conditions were met
    this.checkWin = function(coords) {
        var checkXY = function(x,y) {
            if ((x < 0) || (x > 6)
             || (y < 0) || (y > 5))
                return false;
            return true;
        };
        
        var checkNeighbour = function(coords, xFunc, yFunc) {
            var arr = new Array();
            var current = game.disc;
            var x = coords[0];
            var y = coords[1];
            
            while (current.colour === game.disc.colour) {
                arr.push(new Array(current,x,y));
                
                if (xFunc === '+')
                    x++;
                else if (xFunc === '-')
                    x--;
                if (yFunc === '+')
                    y++;
                else if (yFunc === '-')
                    y--;
                
                if (checkXY(x,y)) {
                    current = game.board.slots[x][y];
                    if (current === null)
                        break;
                } else
                    break;
            }
            return arr;
        };

        // down
        var xFunc = '+';
        var yFunc = '';
        this.row = checkNeighbour(coords, xFunc, yFunc);
        if (this.row.length > 3) {
            this.win();
            return true;
        }
        
        // sw
        var xFunc = '+';
        var yFunc = '-';
        this.row = checkNeighbour(coords, xFunc, yFunc);
        if (this.row.length > 3) {
            this.win();
            return true;
        }
        
        // ne
        var xFunc = '-';
        var yFunc = '+';
        var row2 = checkNeighbour(coords, xFunc, yFunc);
        row2.shift();
        this.row = this.row.concat(row2);
        if (this.row.length > 3) {
            this.win();
            return true;
        }
        
        // se
        var xFunc = '+';
        var yFunc = '+';
        this.row = checkNeighbour(coords, xFunc, yFunc);
        if (this.row.length > 3) {
            this.win();
            return true;
        }
        
        // nw
        var xFunc = '-';
        var yFunc = '-';
        var row2 = checkNeighbour(coords, xFunc, yFunc);
        row2.shift();
        this.row = this.row.concat(row2);
        if (this.row.length > 3) {
            this.win();
            return true;
        }
        
        // left
        var xFunc = '';
        var yFunc = '-';
        this.row = checkNeighbour(coords, xFunc, yFunc);
        if (this.row.length > 3) {
            this.win();
            return true;
        }
        
        // right
        var xFunc = '';
        var yFunc = '+';
        var row2 = checkNeighbour(coords, xFunc, yFunc);
        row2.shift();
        this.row = this.row.concat(row2);
        if (this.row.length > 3) {
            this.win();
            return true;
        }
        
        return false;
    };

    this.win = function() {
        var player;
        for (var i=0;i<game.players.length;i++) {
    		player = game.players[i];
            if (player.name === game.currentPlayer.name)
                player.wins++;
            else 
                player.losses++;
            player.games++;
            player.score = Math.floor((player.wins / player.games) * 10);
    		storage.saveItem(player.name, player);
        }
        setInterval(renderer.displayWinner,200);
    };

// check if board is full
    this.checkTie = function() {
        if (game.playes > 42)  {
            renderer.displayTie();
            return false;
        }
        return false;
    };
    
// create new game piece    
    this.createDisc = function() {
    // create disc
        canvas = document.getElementById("discCanvas");
        disc = new Disc(830, 60, this.currentPlayer.colour);

    // register drag and drop events
        canvas.onmousedown = myDown;
        canvas.onmouseup = myUp;
        canvas.onmousemove = myMove;
        canvas.canDrag = false;

//    // register event listener to show mouse position
//        canvas.addEventListener('mousemove', function(event) {
//            var mousePos = getMousePos(canvas, event);
//            var message = 'Mouse position: ' + mousePos.x + ',' + mousePos.y;
//            writeMessage(canvas, message);
//        }, false);

        return disc;
    };
    
// create new player    
    this.login = function() {
        player = new Player(this.players.length);
        player.name = document.getElementById("userName").value;
        player.colour = document.getElementById("colour").value;
        var stats = storage.loadItem(player.name);

        if (stats) {
            player.wins = stats.wins;
            player.losses = stats.losses
            player.games = stats.games;
        }
        
        this.players.push(player);
        renderer.render(this);
    }
}
