function Board() {
   var self = this;
   self.array = new Array();
   self.numColumns = 0;
   self.numRows = 0;
   self.name = "Board";

   this.init = function (columns, rows) {
      self.numColumns = columns;
      self.numRows = rows;
      var i = 0, j = 0;
      for(i = 0; i < self.numColumns; i++)
      {
         self.array[i] = new Array(self.numRows);
         for(j = 0; j < self.numRows; j++)
         {
            self.array[i][j] = 0;
         }
      }
   }
	
   this.returnGameState = function (columnnum, currentPlayer, lastMove) {
      var i = 0;
      while ((i + 1 < self.array.length) && (self.array[columnnum][i + 1] == 0)) {
         i++;
      }

      if (i == 0) {
         return{ row: i, Gamestate: "Playing" };
      }

      self.array[columnnum][i] = currentPlayer;
      lastMove = {row: i, column: columnnum};


      //////////////////////////////////////////////////////////////
      // UP-RIGHT to DOWN-LEFT DIAGONAL

      var x = columnnum;
      var y = i;
      var numWalked = 0;

      while (y > 0 && x < self.numRows-1) {
         y--;
         x++;
      }

     while (y < self.numColumns && x >= 0) {
         if (self.array[x][y] == currentPlayer) {
            numWalked++;
         } else {
            numWalked=0;
         }

         y++;
         x--;

         if (numWalked > 3) {
            return{ row: i, Gamestate: "Victory" };
         }
     }

     ///////////////////////////////////////////////////////
     // UP-LEFT to DOWN-RIGHT DIAGONAL
      var x = columnnum;
      var y = i;
      numWalked = 0;
      while (y > 0 && x > 0) {
         y--;
         x--;
      }

     while (y < self.numColumns && x < self.numRows) {
         if (self.array[x][y] == currentPlayer) {
            numWalked++;
         } else {
            numWalked=0;
         }

         y++;
         x++;

         if (numWalked > 3) {
            return{ row: i, Gamestate: "Victory" };
         }
     }

     //////////////////////////////////////////////////////////
     // Left to Right (And Right to left)

      var x = 0;
      var y = i;
      numWalked = 0;
     while (x < self.numRows) {
         if (self.array[x][y] == currentPlayer) {
            numWalked++;
         } else {
            numWalked=0;
         }

         x++;

         if (numWalked > 3) {
            return{ row: i, Gamestate: "Victory" };
         }
     }

     //////////////////////////////////////////////////////////
     // Down to Up

      var x = columnnum;
      var y = self.numRows;
      numWalked = 0;
      while (y > 0) {

         if (self.array[x][y] == currentPlayer) {
            numWalked++;
         } else {
            numWalked=0;
         }

         y--;

         if (numWalked > 3) {
            return{row: i, Gamestate: "Victory"};
         }
      }

      var freeSpot = false;
      for (var x = 0; x < self.numColumns ; x++) {
         if (self.array[x][1] == 0) {
            freeSpot = true;
            break;
         }
      } 

      if (!freeSpot) {
         return{ row:i, Gamestate:"Draw!" };
      }

      return { row:i, Gamestate:"Playing" };
   }

   this.clearBoard = function () {
      var i = 0, j = 0;
      for (i = 0; i < self.numColumns; i++) {
         for (j = 0; j < self.numRows; j++) {
            self.array[i][j] = 0;
         }
      }
      
   }
}
