//var supportFunctions = require('supportFunctions');

function mainLogic()
{
   this.init = function()
   {
   
      var animationInProgress = false;
      var currentPlayer = 1;
      
      var gameBoard;
   
      var lastMove = {row:-1, column:-1};
   
      var canvasouter = document.getElementById("Board");
      
      canvasouter.style.height = "100%";
      canvasouter.style.width = "75%";
      canvasouter.height = canvasouter.clientHeight;
      canvasouter.width = canvasouter.clientWidth;
      
      var canvas = canvasouter.getContext('2d');
   
      var numColumns = 7;
      var columnWidth = canvasouter.width/numColumns;
      
      var numRows = 7;
      var rowHeight = canvasouter.height/numRows;
      
      gameBoard = new Array(numColumns);
      for(var i = 0 ; i < numColumns ; i++)
      {
         gameBoard[i] = new Array(numRows);
         for(var j = 0 ; j < numRows ; j++)
         {
            gameBoard[i][j] = 0;
         }
      }
   
      
      redrawGrid();

      
      
      function writeMessage(canvas, message) 
      {
         var context = canvas.getContext('2d');
         context.clearRect(0, 2, canvas.width, canvas.height/numRows-5);
         context.font = '18pt Calibri';
         context.fillStyle = 'black';
         context.fillText(message, 10, 25);
      }


      canvasouter.addEventListener('mousemove', function(evt) 
      {
         if(animationInProgress)
         {
            return;
         }
      
         var mousePos = relMouseCoords(evt);
         var message = 'Mouse position: ' + mousePos.x + ',' + mousePos.y;
         writeMessage(canvasouter, "");
         

         
         drawCircle(mousePos.x , rowHeight/2);
         
         
         
         
         
      }, false);
      
      
      
      
     canvasouter.addEventListener('click' , function(evt)
     {
        if(animationInProgress)
        {
            return;
        }
        
     
        var mousePos = relMouseCoords(evt);
        
        var columnnum = Math.floor((mousePos.x /columnWidth))
        
        
        
        var Status = returnGameState(columnnum);
        
        if(Status.row == 0)
        {
         return;
        }
        
        
        animationInProgress = true;
        window.requestAnimFrame = (function(callback) {
        return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame || function(callback) { window.setTimeout(callback, 1000 / 60); }; })();

      function animate(numFrames ,circleCurrentX, circleCurrentY, circleEndX , circleEndY, circleVelocityX, circleVelocityY , easeValue) 
      {
        var canvas = document.getElementById('Board');
        var context = canvas.getContext('2d');

        // update

        // clear
        context.clearRect(0, 0, canvas.width, canvas.height);
        

        // draw stuff
        redrawGrid();
        redrawPieces();
        
        var dX = circleEndX - circleCurrentX;
        var dY = circleEndY - circleCurrentY;
        
        circleVelocityX = dX * easeValue;
        circleVelocityY = dY * easeValue;
        
        circleCurrentX += circleVelocityX;
        circleCurrentY += circleVelocityY;
        
        drawCircle(circleCurrentX, circleCurrentY);
        

        // request new frame
        requestAnimFrame(function()
        {
          numFrames--;
          if(numFrames > 0)
          {
            animate(numFrames , circleCurrentX ,circleCurrentY , circleEndX ,  circleEndY , circleVelocityX , circleVelocityY , easeValue);
          }
          else
          {
          
             if(Status.Gamestate == "Victory")
             {
                  writeMessage(canvasouter, "Winner: Player " + currentPlayer + ((currentPlayer==1)?" (Red!)":" (Gold!)"));
              
             }
             else if(Status.Gamestate == "Draw!")
             {
                  writeMessage(canvasouter, "Draw!  You're both losers!");
              
             }
             
          
            else
            {
               animationInProgress = false;
               
               if(currentPlayer == 1)
               {
                currentPlayer = 2;
               }
               else
               {
                currentPlayer = 1;
               }
               
               drawCircle(mousePos.x , rowHeight/2);
            
            }
          }
          
        });
      }
      
     animate(30 , mousePos.x , rowHeight/2 , mousePos.x , (rowHeight*Status.row + rowHeight/2), 0 , 0 , .2);
        

    
        
     } ,false);
     
     




      function redrawGrid()
      {
      
         canvas.lineWidth = 2;
         canvas.strokeStyle = '#003300';
      
         canvas.beginPath();
         canvas.moveTo(0,rowHeight);
         
         for(var i = 0; i < numColumns ; i++)
         {
            canvas.lineTo(columnWidth*i,canvasouter.height);
            canvas.moveTo((i+1)*columnWidth,rowHeight);
         }

         canvas.stroke();
         canvas.closePath();
         
         
         
         canvas.beginPath();
         canvas.moveTo(0,0);
         
         for(var i = 0; i < numRows ; i++)
         {
            canvas.lineTo(canvasouter.width,i*rowHeight);
            canvas.moveTo(0,(i+1)*rowHeight);
         }

         canvas.stroke();
         canvas.closePath();
         }


      function returnGameState(columnnum)
      {
         var i = 0;
         while((i+1 < gameBoard.length) && (gameBoard[columnnum][i+1] == 0))
         {
            i++;
         }
         
         if(i == 0)
         {
            return{row:i, Gamestate:"Playing"};
         }
         
         gameBoard[columnnum][i] = currentPlayer;
         lastMove = {row:i, column:columnnum};
         
         
//////////////////////////////////////////////////////////////
         // UP-RIGHT to DOWN-LEFT DIAGONAL
         var x = columnnum;
         var y = i;
         var numWalked = 0;
         

         while(y > 0 && x < numRows-1)
         {
            y--;
            x++;
         }
           // y++;
           // x--;
            
        while(y < numColumns && x >= 0)
        {
            if(gameBoard[x][y] == currentPlayer)
            {
               numWalked++;
            }
            else
            {
               numWalked=0;
            }
            
            y++;
            x--;
            
            if(numWalked > 3)
            {
               return{row:i, Gamestate:"Victory"};
            }
        
        }
        ///////////////////////////////////////////////////////
        // UP-LEFT to DOWN-RIGHT DIAGONAL
         var x = columnnum;
         var y = i;
         numWalked = 0;
         while(y > 0 && x > 0)
         {
            y--;
            x--;
         }
           // y++;
          //  x++;
            
        while(y < numColumns && x < numRows)
        {
            if(gameBoard[x][y] == currentPlayer)
            {
               numWalked++;
            }
            else
            {
               numWalked=0;
            }
            
            y++;
            x++;
            
            if(numWalked > 3)
            {
               return{row:i, Gamestate:"Victory"};
            }
        
        }
        
        //////////////////////////////////////////////////////////
        // Left to Right (And Right to left)
        
         var x = 0;
         var y = i;
         numWalked = 0;
        while(x < numRows)
        {
            if(gameBoard[x][y] == currentPlayer)
            {
               numWalked++;
            }
            else
            {
               numWalked=0;
            }
            
            x++;
            
            if(numWalked > 3)
            {
               return{row:i, Gamestate:"Victory"};
            }
        
        }
        
        //////////////////////////////////////////////////////////
        // Down to Up
        
         var x = columnnum;
         var y = numRows;
         numWalked = 0;
        while(y > 0)
        {
            if(gameBoard[x][y] == currentPlayer)
            {
               numWalked++;
            }
            else
            {
               numWalked=0;
            }
            
            y--;
            
            if(numWalked > 3)
            {
               return{row:i, Gamestate:"Victory"};
            }
        
        }
        
        var freeSpot = false;
        for(var x = 0; x < numColumns ; x++)
        {
            if(gameBoard[x][1] == 0)
            {
               freeSpot = true;
               break;
            }
        } 
        
        if(!freeSpot)
        {
            return{row:i, Gamestate:"Draw!"};
        }
        
            

         
      
      
         return{row:i, Gamestate:"Playing"};
      }
      
      function drawCircle(x , y , Player)
      {
      
         var columnnum = Math.floor((x /columnWidth))
         canvas.beginPath();
         canvas.arc(columnnum*(columnWidth)+(columnWidth/2), y, 23, 0, 2 * Math.PI, false);
         if(typeof Player !== 'undefined')
         {
            if(Player == 1)
            {
               canvas.fillStyle = 'red';
            }
            else
            {
               canvas.fillStyle = 'yellow';
            }
         }
         else
         {
            if(currentPlayer == 1)
            {
               canvas.fillStyle = 'red';
            }
            else
            {
               canvas.fillStyle = 'yellow';
            }
         }
         canvas.fill();
         canvas.lineWidth = 5;
         canvas.strokeStyle = '#003300';
         canvas.stroke();
         canvas.closePath();
      
      }
      
      function redrawPieces()
      {
         for(var i = 0 ; i < numColumns ; i++)
         {
            for(var j = 0 ; j < numRows ; j++)
            {
               if(i == lastMove.column && j == lastMove.row)
               {
                  continue;
               }
            
               if(gameBoard[i][j] == 1)
               {
                  drawCircle(columnWidth*i + columnWidth/2  , rowHeight*j + rowHeight/2 , 1);
               }
               
               else if (gameBoard[i][j] == 2)
               {
                  drawCircle(columnWidth*i + columnWidth/2  , rowHeight*j + rowHeight/2 , 2);
               }
               
            }
         }
      
      }
      
      function drawWinner()
      {
         animationInProgress = true;
         
         
         
         
      } 
      
     }
     
     
   
   
   

   
   


}


var mainEntryPoint = new mainLogic();


































function relMouseCoords(event) {
   // IE9 + Chrome
    if (event.offsetX !== undefined && event.offsetY !== undefined) 
    { 
      return { x: event.offsetX, y: event.offsetY }; 
    }
    // Firefox
    else
    {
      return { x: event.layerX, y: event.layerY };
    }
}

HTMLCanvasElement.prototype.relMouseCoords = relMouseCoords;

function sleep(milliseconds) {
  var start = new Date().getTime();
  for (var i = 0; i < 1e7; i++) {
    if ((new Date().getTime() - start) > milliseconds){
      break;
    }
  }
}
