function dataStorage()
{
   var displayMode = "score";

   this.switchDisplay = function ()
   {
     if(displayMode == "score")
     {
      
      this.loadLadder();
     } 
     
     else
     {
       
      this.load();
     
     } 
   
   }


   this.loadLadder = function ()
   {
      displayMode = "ladder";
   
      var theArray = getArrayFromLocalStorage("PlayerLadder");

      var scoreTable = document.getElementById("scoreTable");
      scoreTable.innerHTML = '';
      var tableHeader = document.createElement("thead");

      
      
      
      
      var headerRow = document.createElement("tr");
      
      var tableColumn = document.createElement("th");
      tableColumn.innerHTML = "Player Name:"
      headerRow.appendChild(tableColumn);
      
      tableColumn = document.createElement("th");
      tableColumn.innerHTML = "Player Wins:"
      headerRow.appendChild(tableColumn);
      
      tableColumn = document.createElement("th");
      tableColumn.innerHTML = "Player Losses:"
      headerRow.appendChild(tableColumn);
      
      tableColumn = document.createElement("th");
      tableColumn.innerHTML = "Player Total:"
      headerRow.appendChild(tableColumn);

      tableColumn = document.createElement("th");
      tableColumn.innerHTML = "Player Score:"
      headerRow.appendChild(tableColumn);
      
      tableHeader.appendChild(headerRow);
      scoreTable.appendChild(tableHeader);
       
      var tableBody = document.createElement("tbody"); 
      scoreTable.appendChild(tableBody);
           
      for(var i = 0; i < theArray.length; i++)
      {
         var tableRow = document.createElement("tr");
         
         tableBody.appendChild(tableRow);
         
         var tableColumn = document.createElement("td");
         tableColumn.innerHTML = theArray[i].name;
         tableRow.appendChild(tableColumn);
         
         tableColumn = document.createElement("td");
         tableColumn.innerHTML = theArray[i].wins;
         tableRow.appendChild(tableColumn);
         
         tableColumn = document.createElement("td");
         tableColumn.innerHTML = theArray[i].losses;
         tableRow.appendChild(tableColumn);
         
         tableColumn = document.createElement("td");
         tableColumn.innerHTML = theArray[i].total;
         tableRow.appendChild(tableColumn);

         tableColumn = document.createElement("td");
         tableColumn.innerHTML = theArray[i].score;
         tableRow.appendChild(tableColumn);

      }
      
   }
   
   this.load = function ()
   {
   
      displayMode = "score";
   
      var theArray = getArrayFromLocalStorage("ScoreBoard");

      var scoreTable = document.getElementById("scoreTable");
      scoreTable.innerHTML = '';
      var tableHeader = document.createElement("thead");

      
      
      
      
      var headerRow = document.createElement("tr");
      
      var tableColumn = document.createElement("th");
      tableColumn.innerHTML = "Player One:"
      headerRow.appendChild(tableColumn);
      
      tableColumn = document.createElement("th");
      tableColumn.innerHTML = "Player Two:"
      headerRow.appendChild(tableColumn);
      
      tableColumn = document.createElement("th");
      tableColumn.innerHTML = "Winner:"
      headerRow.appendChild(tableColumn);
      
      
      
      tableHeader.appendChild(headerRow);
      scoreTable.appendChild(tableHeader);
       
      var tableBody = document.createElement("tbody"); 
      scoreTable.appendChild(tableBody);
           
      for(var i = 0; i < theArray.length; i++)
      {
         var tableRow = document.createElement("tr");
         
         tableBody.appendChild(tableRow);
         
         var tableColumn = document.createElement("td");
         tableColumn.innerHTML = theArray[i].playerOne;
         tableRow.appendChild(tableColumn);
         
         tableColumn = document.createElement("td");
         tableColumn.innerHTML = theArray[i].playerTwo;
         tableRow.appendChild(tableColumn);
         
         tableColumn = document.createElement("td");
         tableColumn.innerHTML = theArray[i].winner;
         tableRow.appendChild(tableColumn);

      }
      
   }
   
   
   
   
   
   this.addEntry = function (playerOne , playerTwo, gameState, winner)
   {
      var entry = 
      {
         playerOne: playerOne,
         playerTwo: playerTwo,
         winner: gameState
      }
      
      var knownPlayers = getArrayFromLocalStorage("PlayerLadder");
      var playerOneFound = false;
      var playerTwoFound = false;
      
      for (var i = 0; i < knownPlayers.length; i++)
      {
         if(knownPlayers[i].name == playerOne)
         {
            playerOneFound = true;
            
            knownPlayers[i].wins = playerOne == winner ? knownPlayers[i].wins +1 : knownPlayers[i].wins;
            knownPlayers[i].losses = playerOne == winner ? knownPlayers[i].losses : knownPlayers[i].losses +1;
            knownPlayers[i].total = knownPlayers[i].total+1;
            knownPlayers[i].score = Math.round((knownPlayers[i].wins / knownPlayers[i].total) * 1000)/100;
         }
         
         else if(knownPlayers[i].name == playerTwo)
         {
            playerTwoFound = true;
            
            knownPlayers[i].wins = playerTwo == winner ? knownPlayers[i].wins +1 : knownPlayers[i].wins;
            knownPlayers[i].losses = playerTwo == winner ? knownPlayers[i].losses : knownPlayers[i].losses +1;
            knownPlayers[i].total = knownPlayers[i].total+1;
            knownPlayers[i].score = Math.round((knownPlayers[i].wins / knownPlayers[i].total) * 1000)/100;
         }
      
      }
      
      
      if(!playerOneFound)
      {
         var player = 
         {
            name: playerOne,
            wins:   playerOne == winner ? 1 : 0,
            losses: playerOne == winner ? 0 : 1,
            total:  1,
            score: playerOne == winner ? 10 : 0
         
         }
         
         knownPlayers.push(player);
      }
      
      if(!playerTwoFound)
      {
         var player = 
         {
            name: playerTwo,
            wins:   playerTwo == winner ? 1 : 0,
            losses: playerTwo == winner ? 0 : 1,
            total:  1,
            score: playerTwo == winner ? 10 : 0
         }
         
         knownPlayers.push(player);
      }
      
      localStorage.setItem("PlayerLadder", JSON.stringify(knownPlayers));
      
      commitEntry(entry);
      
      this.load();
   
   }
   
   var commitEntry = function (newEntry)
   {
      var theArray = getArrayFromLocalStorage("ScoreBoard");
      theArray.unshift(newEntry);
      localStorage.setItem("ScoreBoard", JSON.stringify(theArray));
   }
   
   var updateEntry = function (newEntry)
   {
   
   
   }
   
   this.clear = function ()
   {
      var theArray = new Array();
      localStorage.setItem("ScoreBoard", JSON.stringify(theArray));
      
      var theArray = new Array();
      localStorage.setItem("PlayerLadder", JSON.stringify(theArray));
      
      
      this.load();
   }
   
   function getArrayFromLocalStorage(key) 
   {
      var theArray = localStorage.getItem(key);
      
      if (! theArray)
      {
          theArray = new Array();
      }
      else 
      {
          theArray = JSON.parse(theArray);
      }
   

      return theArray;
   }
  
}
